LIBRARY IEEE;
USE IEEE.std_logic_1164.all; 
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;
LIBRARY UNISIM;
USE UNISIM.vcomponents.all;
LIBRARY UNIMACRO;
USE UNIMACRO.vcomponents.all;
LIBRARY work;
USE work.Latches_Flipflops.all;

ENTITY DMB_V6_7FF IS 
	PORT
	(

-- BPI Prom signals To/From bpi_interface

		prom_a : INOUT STD_LOGIC_VECTOR(22 DOWNTO 0);	   	-- OK		address(22 DOWNTO 0)
		prom_a_21_rs0 : OUT STD_LOGIC;								-- OK  Not connected in prototype
		prom_a_22_rs1 : OUT STD_LOGIC;								-- OK  Not connected in prototype
		prom_d : INOUT STD_LOGIC_VECTOR(15 DOWNTO 0);	   	-- OK		data(15 DOWNTO 0)
		prom_cs_b : OUT STD_LOGIC;										-- OK
		prom_oe_b : OUT STD_LOGIC;										-- OK
		prom_we_b : OUT STD_LOGIC;										-- OK
		prom_le_b : OUT STD_LOGIC;										-- OK

-- From/To VME connector To/From DAQMBV

		vme_data : INOUT STD_LOGIC_VECTOR(15 DOWNTO 0);		-- OK		d(15 DOWNTO 0)
		vme_addr : IN STD_LOGIC_VECTOR(23 DOWNTO 1);			-- OK		a(23 DOWNTO 1)
		vme_am : IN STD_LOGIC_VECTOR(5 DOWNTO 0);				-- OK		am(6 DOWNTO 0)
		vme_gap : IN STD_LOGIC;										-- OK		gap = ga(5)
		vme_ga : IN STD_LOGIC_VECTOR(4 DOWNTO 0);				-- OK		ga(4 DOWNTO 0)
		vme_bg0 : IN STD_LOGIC;										-- OK		NEW!
		vme_bg1 : IN STD_LOGIC;										-- OK		NEW!
		vme_bg2 : IN STD_LOGIC;										-- OK		NEW!
		vme_bg3 : IN STD_LOGIC;										-- OK		NEW!
		vme_as_b : IN STD_LOGIC;									-- OK		as*
		vme_ds_b : IN STD_LOGIC_VECTOR(1 DOWNTO 0);			-- OK		ds1*,ds0*
		vme_sysreset_b : IN STD_LOGIC;							-- OK		sysreset*
		vme_sysfail_b : IN STD_LOGIC;								-- OK		sysfail*
		vme_sysfail_out : OUT STD_LOGIC;							-- OK		NEW!
		vme_berr_b : IN STD_LOGIC;									-- OK		berr*
		vme_berr_out : OUT STD_LOGIC;								-- OK		NEW!
		vme_iack_b : IN STD_LOGIC;									-- OK		iack*
		vme_lword_b : IN STD_LOGIC;								-- OK		lword*
		vme_write_b : IN STD_LOGIC;								-- OK		write*
		vme_clk : IN STD_LOGIC;										-- OK		???
		vme_dtack_v6_b : INOUT STD_LOGIC;							-- OK		dtack*
-- bgb		vme_tovme_b : OUT STD_LOGIC;									-- OK		not (tovme)
		vme_tovme : OUT STD_LOGIC;									-- OK		not (tovme)
		vme_doe : OUT STD_LOGIC;									-- OK		not (doe*)

-- From/To J6 (J3) connector to DMB_CTRL

		ccb_cmd : IN STD_LOGIC_VECTOR(5 DOWNTO 0);			-- OK		ccbcmnd(5 DOWNTO 0)
		ccb_cmd_s : IN STD_LOGIC;									-- OK		ccbcmnd(6)
		ccb_data : IN STD_LOGIC_VECTOR(7 DOWNTO 0);			-- OK		ccbdata(7 DOWNTO 0)
		ccb_data_s : IN STD_LOGIC;									-- OK		ccbdata(8)
		ccb_cal : IN STD_LOGIC_VECTOR(2 DOWNTO 0);			-- OK		ccbcal(14 DOWNTO 12)
		ccb_crsv : IN STD_LOGIC_VECTOR(4 DOWNTO 0);			-- OK		nc (J3/B2), ccbrsv(3 DOWNTO 0) = crsv(3 DOWNTO 0)
		ccb_drsv : IN STD_LOGIC_VECTOR(1 DOWNTO 0);			-- OK		ccbrsv(5 DOWNTO 4) = drsv(1 DOWNTO 0)
		ccb_rsvo : IN STD_LOGIC_VECTOR(4 DOWNTO 0);			-- OK		nc (J3/A21), ccbsrv(10 DOWNTO 7) = rsvo(3 DOWNTO 0)
		ccb_rsvi : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);			-- OK		ccbsrv(14 DOWNTO 12)
		ccb_bx0 : IN STD_LOGIC;										-- OK		bx0
		ccb_bxrst : IN STD_LOGIC;									-- OK		bxrst
		ccb_l1arst : IN STD_LOGIC;									-- OK		l1arst
		ccb_l1acc : IN STD_LOGIC;									-- OK		l1acc
		ccb_l1rls : OUT STD_LOGIC;									-- OK		l1rls
		ccb_clken : IN STD_LOGIC;									-- OK		clkena

		ccb_hardrst : IN STD_LOGIC;								-- OK		
		ccb_softrst : IN STD_LOGIC;								-- OK		

-- From J6/J7 (J3/J4) to FIFOs

		tmb : IN STD_LOGIC_VECTOR(17 DOWNTO 0);				-- OK		f6di(17 DOWNTO 0)
		alct : IN STD_LOGIC_VECTOR(17 DOWNTO 0);				-- OK		f7di(17 DOWNTO 0)
		rawlct : IN STD_LOGIC_VECTOR(5 DOWNTO 0);				-- OK		???
		tmbffclk : IN STD_LOGIC;									-- OK		tmbffclk

-- From/To J3/J4 t/fromo DMB_CTRL

		lctdav1 : IN STD_LOGIC;										-- OK		lctdav1
		lctdav2 : IN STD_LOGIC;										-- OK		lctdav2
--		rsvtd : INOUT STD_LOGIC_VECTOR(7 DOWNTO 0);			
		rsvtd_in : IN STD_LOGIC_VECTOR(4 DOWNTO 0);			-- OK		rstvd(7 DOWNTO 4)
		rsvtd_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);		-- OK		rstvd(2 DOWNTO 0)
		lctrqst : OUT STD_LOGIC_VECTOR(2 DOWNTO 1);			-- OK		lctrqst(2 DOWNTO 1)


-- From/To QPLL (From/To DAQMBV)

		qpll_autorestart : OUT STD_LOGIC;						-- OK		NEW!
		qpll_mode : OUT STD_LOGIC;									-- OK		NEW!
		qpll_extcontrol : OUT STD_LOGIC;							-- OK		NEW!
		qpll_reset : OUT STD_LOGIC;								-- OK		NEW!
		qpll_f0sel : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);		-- OK		NEW!
		qpll_locked : IN STD_LOGIC;								-- OK		NEW!
		qpll_error : IN STD_LOGIC;									-- OK		NEW!

		qpll_clk40MHz_p : IN STD_LOGIC;							-- OK		NEW!
		qpll_clk40MHz_n : IN STD_LOGIC;							-- OK		NEW!
		qpll_clk80MHz_p : IN STD_LOGIC;							-- OK		NEW!
		qpll_clk80MHz_n : IN STD_LOGIC;							-- OK		NEW!
--		qpll_clk160MHz_p : IN STD_LOGIC;							-- NEW!
--		qpll_clk160MHz_n : IN STD_LOGIC;							-- NEW!
		
-- From/To LVMB (From/To DAQMBV and DAQMBC)

		lvmb_pon : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);		-- OK		pwon(6 DOWNTO 1)
		pon_load : OUT STD_LOGIC;								-- OK		loadpwon
		pon_en : OUT STD_LOGIC;									-- OK		pwon_en*
		r_lvmb_pon : IN STD_LOGIC_VECTOR(7 DOWNTO 0);	-- OK		multi(6 DOWNTO 1) (r_pwon(6 DOWNTO 1))
		lvmb_csb : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);		-- OK		multi(13 DOWNTO 7)
		lvmb_sclk : OUT STD_LOGIC;								-- OK		multi(14)
		lvmb_sdin : OUT STD_LOGIC;								-- OK		multi(15)
		lvmb_sdout : IN STD_LOGIC;							   -- OK		multi(16)

-- From/To ADC (From/To DAQMBV)

		adc_sclk : OUT STD_LOGIC;						-- OK		NEW!
		adc_sdain : OUT STD_LOGIC;						-- OK		NEW!
		adc_sdaout : IN STD_LOGIC;						-- OK		NEW!
		adc_cs : OUT STD_LOGIC;							-- OK		NEW!

-- From/To DAC (From/To DAQMBV)

		dac_sclk : OUT STD_LOGIC;						-- OK		NEW!
		dac_sdain : OUT STD_LOGIC;						-- OK		NEW!
		dac_sdaout : IN STD_LOGIC;						-- OK		NEW!
		dac_cs : OUT STD_LOGIC;							-- OK		NEW!

-- To LEDs

		leds : OUT STD_LOGIC_VECTOR(11 DOWNTO 0);	-- OK		NEW!	

-- To Frequency Divider FF

		fd_pre : OUT STD_LOGIC;							-- OK		NEW!	
		fd_clr : OUT STD_LOGIC;							-- OK		NEW!	

-- From Push Buttons

		pb : IN STD_LOGIC_VECTOR(3 DOWNTO 0);		-- OK

-- From/To Test Connector for Single-Ended signals

		d : INOUT STD_LOGIC_VECTOR(63 DOWNTO 0);	-- OK		

-- From/To Test Connector J3 for LVDS signals

		gtx_0_p : IN STD_LOGIC;					-- OK			
		gtx_0_n : IN STD_LOGIC;					-- OK			
		grx_0_p : OUT STD_LOGIC;				-- OK (out)			
		grx_0_n : OUT STD_LOGIC;				-- OK (out)			

		ck_0_p : IN STD_LOGIC;					-- OK			
		ck_0_n : IN STD_LOGIC;					-- OK			
		ck_1_p : IN STD_LOGIC;					-- OK			
		ck_1_n : IN STD_LOGIC;					-- OK			
		tclk_p : IN STD_LOGIC;					-- OK			
		tclk_n : IN STD_LOGIC;					-- OK			
		rxb_p : OUT STD_LOGIC;					-- OK			
		rxb_n : OUT STD_LOGIC;					-- OK			
		
		tx_0_p : OUT STD_LOGIC;					-- OK			
		tx_0_n : OUT STD_LOGIC;					-- OK			
		tx_1_p : OUT STD_LOGIC;					-- OK			
		tx_1_n : OUT STD_LOGIC;					-- OK			
		tx_2_p : OUT STD_LOGIC;					-- OK			
		tx_2_n : OUT STD_LOGIC;					-- OK			
		tx_3_p : OUT STD_LOGIC;					-- OK			
		tx_3_n : OUT STD_LOGIC;					-- OK			
		tx_4_p : OUT STD_LOGIC;					-- OK			
		tx_4_n : OUT STD_LOGIC;					-- OK			
		tx_5_p : OUT STD_LOGIC;					-- OK			
		tx_5_n : OUT STD_LOGIC;					-- OK			
		tx_6_p : OUT STD_LOGIC;					-- OK			
		tx_6_n : OUT STD_LOGIC;					-- OK			
		tx_7_p : OUT STD_LOGIC;					-- OK			
		tx_7_n : OUT STD_LOGIC;					-- OK			
		tx_8_p : OUT STD_LOGIC;					-- OK			
		tx_8_n : OUT STD_LOGIC;					-- OK			
		tx_9_p : OUT STD_LOGIC;					-- OK			
		tx_9_n : OUT STD_LOGIC;					-- OK			
		tx_10_p : OUT STD_LOGIC;				-- OK			
		tx_10_n : OUT STD_LOGIC;				-- OK			

		rx_0_p : IN STD_LOGIC;					-- OK		
		rx_0_n : IN STD_LOGIC;					-- OK			
		rx_1_p : IN STD_LOGIC;					-- OK				
		rx_1_n : IN STD_LOGIC;					-- OK				
		rx_2_p : IN STD_LOGIC;					-- OK				
		rx_2_n : IN STD_LOGIC;					-- OK				
		rx_3_p : IN STD_LOGIC;					-- OK				
		rx_3_n : IN STD_LOGIC;					-- OK				
		rx_4_p : IN STD_LOGIC;					-- OK			
		rx_4_n : IN STD_LOGIC;					-- OK			
		rx_5_p : IN STD_LOGIC;					-- OK				
		rx_5_n : IN STD_LOGIC;					-- OK				
		rx_6_p : IN STD_LOGIC;					-- OK				
		rx_6_n : IN STD_LOGIC;					-- OK				
		rx_7_p : IN STD_LOGIC;					-- OK				
		rx_7_n : IN STD_LOGIC;					-- OK				
		rx_8_p : IN STD_LOGIC;					-- OK			
		rx_8_n : IN STD_LOGIC;					-- OK			
		rx_9_p : IN STD_LOGIC;					-- OK				
		rx_9_n : IN STD_LOGIC;					-- OK				
		rx_10_p : IN STD_LOGIC;					-- OK				
		rx_10_n : IN STD_LOGIC;					-- OK				

-- To/From TX1 

		otx1_01_p : OUT  STD_LOGIC;			-- OK	
		otx1_01_n : OUT  STD_LOGIC;			-- OK	
		otx1_02_p : OUT  STD_LOGIC;			-- OK	
		otx1_02_n : OUT  STD_LOGIC;			-- OK	
		otx1_03_p : OUT  STD_LOGIC;			-- OK	
		otx1_03_n : OUT  STD_LOGIC;			-- OK	
		otx1_04_p : OUT  STD_LOGIC;			-- OK	
		otx1_04_n : OUT  STD_LOGIC;			-- OK	
		otx1_05_p : OUT  STD_LOGIC;			-- OK	
		otx1_05_n : OUT  STD_LOGIC;			-- OK	
		otx1_06_p : OUT  STD_LOGIC;			-- OK	
		otx1_06_n : OUT  STD_LOGIC;			-- OK	
		otx1_07_p : OUT  STD_LOGIC;			-- OK	
		otx1_07_n : OUT  STD_LOGIC;			-- OK	
		otx1_08_p : OUT  STD_LOGIC;			-- OK	
		otx1_08_n : OUT  STD_LOGIC;			-- OK
		otx1_09_p : OUT  STD_LOGIC;			-- OK	
		otx1_09_n : OUT  STD_LOGIC;			-- OK	
		otx1_10_p : OUT  STD_LOGIC;			-- OK	
		otx1_10_n : OUT  STD_LOGIC;			-- OK	
		otx1_11_p : OUT  STD_LOGIC;			-- OK	
		otx1_11_n : OUT  STD_LOGIC;			-- OK	
		otx1_12_p : OUT  STD_LOGIC;			-- OK	
		otx1_12_n : OUT  STD_LOGIC;			-- OK	

		otx1_tx_en : OUT  STD_LOGIC;			-- OK
		otx1_tx_dis : OUT  STD_LOGIC;			-- OK
		otx1_reset : OUT  STD_LOGIC;			-- OK
		otx1_fault : IN  STD_LOGIC;			-- OK
		
-- To/From TX2 

		otx2_01_p : OUT  STD_LOGIC;			-- OK	
		otx2_01_n : OUT  STD_LOGIC;			-- OK	
		otx2_02_p : OUT  STD_LOGIC;			-- OK	
		otx2_02_n : OUT  STD_LOGIC;			-- OK	
		otx2_03_p : OUT  STD_LOGIC;			-- OK	
		otx2_03_n : OUT  STD_LOGIC;			-- OK	
		otx2_04_p : OUT  STD_LOGIC;			-- OK	
		otx2_04_n : OUT  STD_LOGIC;			-- OK	
		otx2_05_p : OUT  STD_LOGIC;			-- OK	
		otx2_05_n : OUT  STD_LOGIC;			-- OK	
		otx2_06_p : OUT  STD_LOGIC;			-- OK	
		otx2_06_n : OUT  STD_LOGIC;			-- OK	
		otx2_07_p : OUT  STD_LOGIC;			-- OK	
		otx2_07_n : OUT  STD_LOGIC;			-- OK	
		otx2_08_p : OUT  STD_LOGIC;			-- OK	
		otx2_08_n : OUT  STD_LOGIC;			-- OK	
		otx2_09_p : OUT  STD_LOGIC;			-- OK	
		otx2_09_n : OUT  STD_LOGIC;			-- OK	
		otx2_10_p : OUT  STD_LOGIC;			-- OK	
		otx2_10_n : OUT  STD_LOGIC;			-- OK	
		otx2_11_p : OUT  STD_LOGIC;			-- OK	
		otx2_11_n : OUT  STD_LOGIC;			-- OK	
		otx2_12_p : OUT  STD_LOGIC;			-- OK	
		otx2_12_n : OUT  STD_LOGIC;			-- OK	

		otx2_tx_en : OUT  STD_LOGIC;			-- OK	
		otx2_tx_dis : OUT  STD_LOGIC;			-- OK	
		otx2_reset : OUT  STD_LOGIC;			-- OK	
		otx2_fault : IN  STD_LOGIC;			-- OK	

-- From/To RX1 

		orx1_01_p : IN  STD_LOGIC;				-- OK		
		orx1_01_n : IN  STD_LOGIC;				-- OK		
		orx1_02_p : IN  STD_LOGIC;				-- OK	
		orx1_02_n : IN  STD_LOGIC;				-- OK
		orx1_03_p : IN  STD_LOGIC;				-- OK
		orx1_03_n : IN  STD_LOGIC;				-- OK
		orx1_04_p : IN  STD_LOGIC;				-- OK
		orx1_04_n : IN  STD_LOGIC;				-- OK
		orx1_05_p : IN  STD_LOGIC;				-- OK
		orx1_05_n : IN  STD_LOGIC;				-- OK
		orx1_06_p : IN  STD_LOGIC;				-- OK
		orx1_06_n : IN  STD_LOGIC;				-- OK
		orx1_07_p : IN  STD_LOGIC;				-- OK
		orx1_07_n : IN  STD_LOGIC;				-- OK
		orx1_08_p : IN  STD_LOGIC;				-- OK
		orx1_08_n : IN  STD_LOGIC;				-- OK
		orx1_09_p : IN  STD_LOGIC;				-- OK
		orx1_09_n : IN  STD_LOGIC;				-- OK
		orx1_10_p : IN  STD_LOGIC;				-- OK
		orx1_10_n : IN  STD_LOGIC;				-- OK
		orx1_11_p : IN  STD_LOGIC;				-- OK
		orx1_11_n : IN  STD_LOGIC;				-- OK
		orx1_12_p : IN  STD_LOGIC;				-- OK
		orx1_12_n : IN  STD_LOGIC;				-- OK

		orx1_rx_en : OUT  STD_LOGIC;			-- OK
		orx1_en_sd : OUT  STD_LOGIC;			-- OK
		orx1_sd : IN  STD_LOGIC;				-- OK
		orx1_sq_en : OUT  STD_LOGIC;			-- OK

-- From/To RX2 

		orx2_01_p : IN  STD_LOGIC;				-- OK		
		orx2_01_n : IN  STD_LOGIC;				-- OK	
		orx2_02_p : IN  STD_LOGIC;				-- OK	
		orx2_02_n : IN  STD_LOGIC;				-- OK	
		orx2_03_p : IN  STD_LOGIC;				-- OK	
		orx2_03_n : IN  STD_LOGIC;				-- OK	
		orx2_04_p : IN  STD_LOGIC;				-- OK	
		orx2_04_n : IN  STD_LOGIC;				-- OK	
		orx2_05_p : IN  STD_LOGIC;				-- OK	
		orx2_05_n : IN  STD_LOGIC;				-- OK	
		orx2_06_p : IN  STD_LOGIC;				-- OK	
		orx2_06_n : IN  STD_LOGIC;				-- OK	
		orx2_07_p : IN  STD_LOGIC;				-- OK	
		orx2_07_n : IN  STD_LOGIC;				-- OK	
		orx2_08_p : IN  STD_LOGIC;				-- OK	
		orx2_08_n : IN  STD_LOGIC;				-- OK	
		orx2_09_p : IN  STD_LOGIC;				-- OK	
		orx2_09_n : IN  STD_LOGIC;				-- OK	
		orx2_10_p : IN  STD_LOGIC;				-- OK	
		orx2_10_n : IN  STD_LOGIC;				-- OK	
		orx2_11_p : IN  STD_LOGIC;				-- OK	
		orx2_11_n : IN  STD_LOGIC;				-- OK	
		orx2_12_p : IN  STD_LOGIC;				-- OK	
		orx2_12_n : IN  STD_LOGIC;				-- OK	

		orx2_rx_en : OUT  STD_LOGIC;			-- OK	
		orx2_en_sd : OUT  STD_LOGIC;			-- OK	
		orx2_sd : IN  STD_LOGIC;				-- OK	
		orx2_sq_en : OUT  STD_LOGIC;			-- OK	

-- From/To OT1 (GigaBit Link)

		gl0_tx_p : OUT  STD_LOGIC;				-- OK
		gl0_tx_n : OUT  STD_LOGIC;				-- OK
		gl0_rx_p : IN  STD_LOGIC;				-- OK
		gl0_rx_n : IN  STD_LOGIC;				-- OK

-- From/To OT2 (GigaBit Link)

		gl1_tx_p : OUT  STD_LOGIC;				-- OK
		gl1_tx_n : OUT  STD_LOGIC;				-- OK
		gl1_rx_p : IN  STD_LOGIC;				-- OK
		gl1_rx_n : IN  STD_LOGIC;				-- OK

-- From IC7 (Clock Driver CDC)

		cdc_clk_0_p : IN  STD_LOGIC;			-- OK
		cdc_clk_0_n : IN  STD_LOGIC;			-- OK
		cdc_clk_1_p : IN  STD_LOGIC;			-- OK
		cdc_clk_1_n : IN  STD_LOGIC;			-- OK
		cdc_clk_2_p : IN  STD_LOGIC;			-- OK
		cdc_clk_2_n : IN  STD_LOGIC;			-- OK
		cdc_clk_3_p : IN  STD_LOGIC;			-- OK
		cdc_clk_3_n : IN  STD_LOGIC;			-- OK
		cdc_clk_4_p : IN  STD_LOGIC;			-- OK
		cdc_clk_4_n : IN  STD_LOGIC;			-- OK
		cdc_clk_5_p : IN  STD_LOGIC;			-- OK
		cdc_clk_5_n : IN  STD_LOGIC;			-- OK
		cdc_clk_6_p : IN  STD_LOGIC;			-- OK
		cdc_clk_6_n : IN  STD_LOGIC;			-- OK
		cdc_clk_7_p : IN  STD_LOGIC;			-- OK
		cdc_clk_7_n : IN  STD_LOGIC;			-- OK

-- From IC31 

		gl0_clk : IN  STD_LOGIC;				-- OK
		gl1_clk : IN  STD_LOGIC;				-- OK
		
		done_in : IN  STD_LOGIC 

-- Configuration (FPGA inputs) 

-- Guido program_b :  IN  STD_LOGIC;
-- Guido init_b :  IN  STD_LOGIC;
-- Guido m2 :  IN  STD_LOGIC;
-- Guido m1 :  IN  STD_LOGIC;
-- Guido m0 :  IN  STD_LOGIC;
-- Guido prom_d :  IN  STD_LOGIC_VECTOR (15 downto 0);		-- ok
-- Guido tdi :  IN  STD_LOGIC;
-- Guido tms :  IN  STD_LOGIC;
-- Guido tck :  IN  STD_LOGIC;

-- Configuration (FPGA outputs) 

-- Guido tdo :  OUT  STD_LOGIC;
-- Guido prom_a :  OUT  STD_LOGIC_VECTOR (22 downto 0);
-- Guido prom_cs_b :  OUT  STD_LOGIC;								-- ok
-- Guido prom_oe_b :  OUT  STD_LOGIC;								-- ok
-- Guido prom_we_b :  OUT  STD_LOGIC;								-- ok
-- Guido prom_le_b :  OUT  STD_LOGIC;								-- ok
-- Guido cclk :  INOUT  STD_LOGIC;
-- Guido done :  OUT  STD_LOGIC

	);
END DMB_V6_7FF;

ARCHITECTURE DMB_V6_7FF_ARCH OF DMB_V6_7FF IS 

-- bgb 
-- bgb  Added Chip Scope Pro Controller
-- bgb 
-- Synplicity black box declaration
attribute syn_black_box : boolean;

--component csp_control_j3_u4
--  PORT (
--    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL2 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL3 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0)
--	 );
--
--end component;
--attribute syn_black_box of csp_control_j3_u4: component is true;

--component csp_control_j3_u5
--  PORT (
--    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL2 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL3 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL4 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0)
--	 );
--
--end component;
--attribute syn_black_box of csp_control_j3_u5: component is true;

--component csp_control_j3_u6
--  PORT (
--    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL2 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL3 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL4 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL5 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0)
--	 );
--
--end component;
--attribute syn_black_box of csp_control_j3_u6: component is true;

component csp_control_j3_u7
  PORT (
    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL2 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL3 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL4 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL5 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL6 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0)
	 );

end component;
attribute syn_black_box of csp_control_j3_u7: component is true;


-- bgb 
-- bgb End of Chip Scope Pro Control declaration
-- bgb 


component clk125_mmcm
port
 (-- Clock in ports
  CLK_IN1           : in     std_logic;
  -- Clock out ports
  CLK_OUT1          : out    std_logic;
  CLK_OUT2          : out    std_logic;
  CLK_OUT3          : out    std_logic;
  CLK_OUT4          : out    std_logic;
  CLK_OUT5          : out    std_logic;
  CLK_OUT6          : out    std_logic;
  CLK_OUT7          : out    std_logic
 );
end component;


component bpi_ctrl
	generic (
     USE_CHIPSCOPE : integer := 1
	);
	port(
-- Chip Scope Pro control signals -- bgb

	BPI_VIO_CNTRL : inout std_logic_vector(35 downto 0);       -- bgb
	BPI_LA_CNTRL  : inout std_logic_vector(35 downto 0);       -- bgb

	CLK           : in std_logic; -- 40 MHz clock
	CLK1MHZ       : in std_logic; --  1 MHz clock for timers
	RST           : IN STD_LOGIC;
--	Interface Signals to/from VME interface
	BPI_CMD_FIFO_DATA : in std_logic_vector(15 downto 0);  -- Data for command FIFO
	BPI_WE            : in std_logic;                      -- Command FIFO write enable  (pulse one clock cycle for one write)
	BPI_RE            : in std_logic;                      -- Read back FIFO read enable  (pulse one clock cycle for one read)
	BPI_DSBL          : in std_logic;                      -- Disable parsing of BPI commands in the command FIFO (while being filled)
	BPI_ENBL          : in std_logic;                      -- Enable  parsing of BPI commands in the command FIFO
	BPI_RBK_FIFO_DATA : out std_logic_vector(15 downto 0); -- Data on output of the Read back FIFO
	BPI_RBK_WRD_CNT   : out std_logic_vector(10 downto 0); -- Word count of the Read back FIFO (number of available reads)
	BPI_STATUS        : out std_logic_vector(15 downto 0); -- FIFO status bits and latest value of the PROM status register. 
	BPI_TIMER         : out std_logic_vector(31 downto 0); -- General timer
-- Signals to/from low level BPI interface
	BPI_BUSY          : in std_logic;                      --  
	BPI_DATA_FROM     : in std_logic_vector(15 downto 0);  -- 
	BPI_LOAD_DATA     : in std_logic;                      --  
	BPI_ACTIVE        : out std_logic;                     --  
	BPI_OP            : out std_logic_vector(1 downto 0);  -- 
	BPI_ADDR          : out std_logic_vector(22 downto 0); -- 
	BPI_DATA_TO       : out std_logic_vector(15 downto 0); -- 
	BPI_EXECUTE       : out std_logic                      --  
);
end component;
component bpi_interface
	port(
	CLK           : in std_logic; -- 40 MHz clock
	RST           : in std_logic;
	ADDR          : in std_logic_vector(22 downto 0);    -- Bank/Array Address 
	CMD_DATA_OUT  : in std_logic_vector(15 downto 0);    -- Command or Data being written to FLASH device
	OP            : in std_logic_vector(1 downto 0);     -- Operation: 00-standby, 01-write, 10-read, 11-not allowed(standby)
	EXECUTE       : in std_logic;                        -- 
	DATA_IN       : out std_logic_vector(15 downto 0);   -- Data read from FLASH device
	LOAD_DATA     : out std_logic;                       -- Clock enable signal for capturing Data read from FLASH device
	BUSY          : out std_logic;                       -- Operation in progress signal (not ready)
-- signals for Dual purpose data lines
	BPI_ACTIVE    : in std_logic;                        -- set to 1 when data lines are for BPI communications.
	DUAL_DATA     : in std_logic_vector(15 downto 0);    -- Data provided for non BPI communications
-- external connections cooresponding to I/O pins
	BPI_AD        : inout std_logic_vector(22 downto 0); -- 
	CFG_DAT       : inout std_logic_vector(15 downto 0); -- 
	RS0           : out std_logic;                       -- 
	RS1           : out std_logic;                       -- 
	FCS_B         : out std_logic;                       -- 
	FOE_B         : out std_logic;                       -- 
	FWE_B         : out std_logic;                       -- 
	FLATCH_B      : out std_logic                        -- 
);
end component;


COMPONENT dmb_receiver
  generic (
     USE_2p56GbE : integer := 1;
     SIM_SPEEDUP : integer := 0
  );
	port(
-- Chip Scope Pro Logic Analyzer control -- bgb

    CSP_GTX_MAC_LA_CTRL: inout std_logic_vector(35 downto 0);       -- bgb
    CSP_PKT_FRM_LA_CTRL: inout std_logic_vector(35 downto 0);       -- bgb
    CSP_FIFO_LA_CTRL   : inout std_logic_vector(35 downto 0);       -- bgb

   RST : IN STD_LOGIC;
--	// External signals
	ORX2_01_N : IN STD_LOGIC;
	ORX2_01_P : IN STD_LOGIC;
	ORX2_02_N : IN STD_LOGIC;
	ORX2_02_P : IN STD_LOGIC;
	ORX2_03_N : IN STD_LOGIC;
	ORX2_03_P : IN STD_LOGIC;
	ORX2_04_N : IN STD_LOGIC;
	ORX2_04_P : IN STD_LOGIC;
	ORX2_05_N : IN STD_LOGIC;
	ORX2_05_P : IN STD_LOGIC;
	ORX2_06_N : IN STD_LOGIC;
	ORX2_06_P : IN STD_LOGIC;
	ORX2_07_N : IN STD_LOGIC;
	ORX2_07_P : IN STD_LOGIC;
	ORX2_08_N : IN STD_LOGIC;
	ORX2_08_P : IN STD_LOGIC;
	ORX2_09_N : IN STD_LOGIC;
	ORX2_09_P : IN STD_LOGIC;
	ORX2_10_N : IN STD_LOGIC;
	ORX2_10_P : IN STD_LOGIC;
	ORX2_11_N : IN STD_LOGIC;
	ORX2_11_P : IN STD_LOGIC;
	ORX2_12_N : IN STD_LOGIC;
	ORX2_12_P : IN STD_LOGIC;
--	// Internal signals
	FIFO_VME_MODE : IN STD_LOGIC;
	FIFO_SEL : OUT STD_LOGIC_VECTOR(8 downto 1);
	RD_EN_FF : OUT STD_LOGIC_VECTOR(8 downto 1);
	WR_EN_FF : OUT STD_LOGIC_VECTOR(8 downto 1);
	FF_DATA_IN : OUT STD_LOGIC_VECTOR(15 downto 0);
	FF_DATA_OUT : OUT STD_LOGIC_VECTOR(15 downto 0);
	FF_WRD_CNT : OUT STD_LOGIC_VECTOR(11 downto 0);
	FF_STATUS : OUT STD_LOGIC_VECTOR(15 downto 0);
	DMBVME_CLK_S2 : IN STD_LOGIC;
	DAQ_RX_125REFCLK : IN STD_LOGIC;
	DAQ_RX_160REFCLK_115_0 : IN STD_LOGIC
  );
END COMPONENT;


COMPONENT LVMB_ADC_SDO_MUX IS
	port (

		adc_sdo : IN STD_LOGIC_VECTOR(6 downto 0);
		adc_ce : IN STD_LOGIC_VECTOR(6 downto 0);
		sdo : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT LVMB_ADC IS
	port (

		scl : IN STD_LOGIC;
		sdi : IN STD_LOGIC;
		sdo : INOUT STD_LOGIC;
		ce : IN STD_LOGIC;
		rst : IN STD_LOGIC;
		device : IN STD_LOGIC_VECTOR(3 downto 0)
	);
END COMPONENT;


COMPONENT DCFEB_V6 is
  port (
 		adc_mask: INOUT STD_LOGIC_VECTOR(11 downto 0);
		
	   trst : IN STD_LOGIC;
	   tck : IN STD_LOGIC;
 		tms : IN STD_LOGIC;
 		tdi : IN STD_LOGIC;
		rtn_shft_en : OUT STD_LOGIC;
  		tdo : INOUT STD_LOGIC);

end COMPONENT;

COMPONENT dmb_ctrl IS
	port (

		ccb_cmd : IN STD_LOGIC_VECTOR (5 downto 0);				-- ccbcmnd(5 downto 0) - from J3
		ccb_cmd_s : IN STD_LOGIC;										-- ccbcmnd(6) - from J3
		ccb_data : IN STD_LOGIC_VECTOR (7 downto 0);				-- ccbdata(7 downto 0) - from J3
		ccb_data_s : IN STD_LOGIC;										-- ccbdata(8) - from J3
		ccb_cal : IN STD_LOGIC_VECTOR (2 downto 0);				-- ccbcal(2 downto 0) - from J3
		ccb_crsv : IN STD_LOGIC_VECTOR (4 downto 0);				-- NEW [ccbrsv(6)], ccbrsv(3 downto 0) - from J3
		ccb_drsv : IN STD_LOGIC_VECTOR (1 downto 0);				-- ccbrsv(5 downto 4) - from J3
		ccb_rsvo : IN STD_LOGIC_VECTOR (4 downto 0);				-- NEW [ccbrsv(11)], ccbrsv(10 downto 7) - from J3
		ccb_rsvi : OUT STD_LOGIC_VECTOR (2 downto 0);			-- ccbrsv(14 downto 12) - to J3
		ccb_bx0 : IN STD_LOGIC;											-- bx0 - from J3
		ccb_bxrst : IN STD_LOGIC;										-- bxrst - from J3
		ccb_l1acc : IN STD_LOGIC;										-- l1acc - from J3
		ccb_l1arst : IN STD_LOGIC;										-- l1rst - from J3
		ccb_l1rls : OUT STD_LOGIC;										-- l1rls - to J3
		ccb_clken : IN STD_LOGIC;										-- clken - from J3

		rawlct : IN STD_LOGIC_VECTOR (5 downto 0);				-- rawlct(5 downto 0) - from J4
		lctdav1 : IN STD_LOGIC;											-- lctdav1 - from J4
		lctdav2 : IN STD_LOGIC;											-- lctdav2 - from J4
		lctrqst : OUT STD_LOGIC_VECTOR (2 downto 1);				-- lctrqst(2 downto 1) - to J4
		rsvtd_in : IN STD_LOGIC_VECTOR(4 DOWNTO 0);				-- spare(7 DOWNTO 3) - to J4
		rsvtd_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);			-- spare(2 DOWNTO 0) - from J4

-- From GigaLinks

		grx0_data : IN STD_LOGIC_VECTOR(15 DOWNTO 0);	-- glin(15 downto 0)									  
		grx0_data_valid : IN STD_LOGIC;			 
		grx1_data : IN STD_LOGIC_VECTOR(15 DOWNTO 0);	-- glin(15 downto 0)											  
		grx1_data_valid : IN STD_LOGIC;			 
	
-- From GigaLinks

		gtx0_data : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);	-- dout(15 downto 0)											  
		gtx0_data_valid : OUT STD_LOGIC;			 
		gtx1_data : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);	-- dout(15 downto 0)											  
		gtx1_data_valid : OUT STD_LOGIC;			 
	
-- From/To FIFOs

		fifo_rd_ck : OUT STD_LOGIC;										  
		fifo_rd_en : OUT STD_LOGIC_VECTOR(9 DOWNTO 1);										  
		fifo_sel : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);			 

		fifo_out : IN STD_LOGIC_VECTOR(17 DOWNTO 0);				

		fifo_mrst_b : OUT STD_LOGIC;									-- ok -> fifo_mrst* - to FIFOs 
		fifo_prst_b : OUT STD_LOGIC;									-- ok -> fifo_pst* - to FIFOs 

		fifo_full_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- full*(7 DOWNTO 1) - from FIFOs 
		fifo_half_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- half*(7 DOWNTO 1) - from FIFOs 
		fifo_pae_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- paef*(7 DOWNTO 1) - from FIFOs 
		fifo_empty_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- emptyf*(7 DOWNTO 1) - from FIFOs 

-- From/To DCFEBs (FF-EMU-MOD)

		ul_dav: IN STD_LOGIC_VECTOR(6 DOWNTO 0);						-- davf(5 DOWNTO 1) - from DCFEBs 
		ul_movlp: IN STD_LOGIC_VECTOR(6 DOWNTO 0);					-- movlp(5 DOWNTO 1) - from DCFEBs

		dl_lct : OUT STD_LOGIC_VECTOR(7 DOWNTO 1);					-- lctf(5 DOWNTO 1) - to DCFEBs
		dl_gtrig : OUT STD_LOGIC;											-- febrst - to DCFEBs
		dl_injpulse : OUT STD_LOGIC;										-- inject - to DCFEBs
		dl_extpulse : OUT STD_LOGIC										-- extpulse - to DCFEBs

);
	
end COMPONENT;

COMPONENT dmb_vme IS
	port (

-- Chip Scope Pro Logic Analyzer control -- bgb

    CSP_VME_LA_CTRL: inout std_logic_vector(35 downto 0);       -- bgb
    CSP_CFEB_JTAG_LA_CTRL: inout std_logic_vector(35 downto 0); -- bgb
	 VME_LA_TRG: inout std_logic;                                -- bgb

-- VME signals

		vme_addr : IN STD_LOGIC_VECTOR (23 downto 1);			-- adr(23 downto 1)
		vme_data_in : IN STD_LOGIC_VECTOR (15 downto 0);		-- data_in(15 downto 0)
		vme_data_out : OUT STD_LOGIC_VECTOR (15 downto 0);		-- data_out(15 downto 0)
		vme_am : IN STD_LOGIC_VECTOR (5 downto 0);				-- am(5 downto 0)
		vme_ga : IN STD_LOGIC_VECTOR (4 downto 0);				-- iga(4 downto 0) -> ga*(4 downto 0)
		vme_gap : IN STD_LOGIC;											-- iga(5) -> ga*(5)
		vme_ds_b : IN STD_LOGIC_VECTOR(1 DOWNTO 0);				-- ids1* -> ds1*, ids0* -> ds0*
		vme_as_b : IN STD_LOGIC;										-- ias* -> as*
		vme_lword_b : IN STD_LOGIC;									-- ilword* -> lword*
		vme_write_b : IN STD_LOGIC;									-- iwrite* -> write*
		vme_iack_b : IN STD_LOGIC;										-- inack* -> iack*
		vme_sysreset_b : IN STD_LOGIC;								-- isysrst* -> sysrest*
		vme_sysfail_b : IN STD_LOGIC;									-- isysfail* -> sysfail
		vme_sysfail_out : OUT STD_LOGIC;								-- NEW (N.1)
		vme_berr_b : IN STD_LOGIC;										-- iberr* -> berr*
		vme_berr_out : OUT STD_LOGIC;									-- NEW (N.1)
		vme_dtack_b : INOUT STD_LOGIC;									-- dtack* -> odtack*
		vme_tovme : OUT STD_LOGIC;										-- tovme
		vme_tovme_b : OUT STD_LOGIC;									-- tovme*
		vme_doe : OUT STD_LOGIC;										-- doe
		vme_doe_b : OUT STD_LOGIC;										-- doe*

-- Clock

		clk : IN STD_LOGIC;												-- fpgaclk (40MHz)
		clk_s1 : IN STD_LOGIC;											-- midclk (10MHz) 
		clk_s2  : IN STD_LOGIC;											-- slowclk (2.5MHz)
		clk_s3  : IN STD_LOGIC; 										-- slowclk2 (1.25MHz)

-- Reset

		rst : IN STD_LOGIC;												-- iglobalrst

-- JTAG signals To/From DCFEBs

		dl_jtag_tck : INOUT STD_LOGIC_VECTOR (6 downto 0);				
		dl_jtag_tms : INOUT STD_LOGIC;				
		dl_jtag_tdi : INOUT STD_LOGIC;				
		dl_jtag_tdo : IN STD_LOGIC_VECTOR (6 downto 0);				
		dl_rtn_shft_en  : IN STD_LOGIC_VECTOR (6 downto 0);
		ul_jtag_tck : IN STD_LOGIC_VECTOR (6 downto 0);				
		ul_jtag_tms : IN STD_LOGIC_VECTOR (6 downto 0);				
		ul_jtag_tdi : IN STD_LOGIC_VECTOR (6 downto 0);

-- reprogram To DCFEB FPGA (CFEBPRG)

		dl_reprogram : OUT STD_LOGIC_VECTOR(6 downto 0);

-- Done from DCFEB FPGA (CFEBPRG)

		ul_done : IN STD_LOGIC_VECTOR(6 downto 0);


-- To/From O-DMB ADC

		adc_cs : OUT STD_LOGIC;											
		adc_sclk : OUT STD_LOGIC;										
		adc_sdain : OUT STD_LOGIC;										
		adc_sdaout : IN STD_LOGIC;										
		
-- To/From O-DMB DAC

		dac_cs : OUT STD_LOGIC;											
		dac_sclk : OUT STD_LOGIC;										
		dac_sdain : OUT STD_LOGIC;										
		dac_sdaout : IN STD_LOGIC;										
		
-- To/From DCFEB FIFOs

		fifo_wr_ck : OUT STD_LOGIC;	
		fifo_wr_en : OUT STD_LOGIC_VECTOR (9 downto 1);
		fifo_rw_en : OUT STD_LOGIC_VECTOR (9 downto 1);	
		fifo_rm_en : OUT STD_LOGIC_VECTOR (9 downto 1);	
		fifo_tm_en : OUT STD_LOGIC_VECTOR (9 downto 1);	

		fifo_in : OUT STD_LOGIC_VECTOR (17 downto 0);			
		fifo_out : IN STD_LOGIC_VECTOR (17 downto 0);	

-- To/From DCFEB ADCs and DACs

		dl_spi_cs0 : OUT STD_LOGIC_VECTOR(6 downto 0);			
		dl_spi_cs1 : OUT STD_LOGIC_VECTOR(6 downto 0);			
		dl_spi_scl : OUT STD_LOGIC_VECTOR(6 downto 0);			
		dl_spi_sda : OUT STD_LOGIC_VECTOR(6 downto 0);			 
		ul_spi_scl : IN STD_LOGIC_VECTOR(6 downto 0);			
		ul_spi_sda : IN STD_LOGIC_VECTOR(6 downto 0);			 
		ul_spi_busy : IN STD_LOGIC_VECTOR(6 downto 0);			 

-- Token To/From DCFEB FF-EMU 

		dl_tkn : OUT STD_LOGIC_VECTOR(6 downto 0);				
		ul_tkn : IN STD_LOGIC_VECTOR(6 downto 0);					

-- I2C control signals To/From DCFEB FF-EMU (CFEBI2C)

		dl_i2c_scl : OUT STD_LOGIC_VECTOR(6 downto 0);				
		dl_i2c_sda : OUT STD_LOGIC_VECTOR(6 downto 0);				
		ul_i2c_scl : IN STD_LOGIC_VECTOR(6 downto 0);					
		ul_i2c_sda : IN STD_LOGIC_VECTOR(6 downto 0);					

-- From/To QPLL

		qpll_autorestart : OUT STD_LOGIC;						
		qpll_mode : OUT STD_LOGIC;									
		qpll_extcontrol : OUT STD_LOGIC;							
		qpll_reset : OUT STD_LOGIC;								
		qpll_f0sel : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);		
		qpll_locked : IN STD_LOGIC;								
		qpll_error : IN STD_LOGIC;									

-- From/To LVMB

		lvmb_pon : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		pon_load : OUT STD_LOGIC;
		pon_oe_b : OUT STD_LOGIC;
		r_lvmb_pon : IN STD_LOGIC_VECTOR(7 DOWNTO 0);		
		lvmb_csb : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);			
		lvmb_sclk : OUT STD_LOGIC;
		lvmb_sdin : OUT STD_LOGIC;			
		lvmb_sdout : IN STD_LOGIC;

		diagout_cfebjtag  : OUT std_logic_vector(17 downto 0);
		
-- From/To FIFOs

		tfifo_data : IN std_logic_vector(15 downto 0);
		tfifo_wc : IN std_logic_vector(11 downto 0);
		tfifo_rc : IN std_logic_vector(11 downto 0);
		tfifo_str : IN std_logic_vector(15 downto 0);
		tfifo_wr_en : OUT std_logic_vector(7 downto 0);
		tfifo_rd_en : OUT std_logic_vector(7 downto 0);
		tfifo_sel : OUT std_logic_vector(7 downto 0);
		tfifo_mode : OUT std_logic;
		tfifo_rst : OUT std_logic;
		
-- To/From BPI_PORT 

	BPI_RST           : out std_logic;                      -- Resets BPI interface state machines
	BPI_CMD_FIFO_DATA : out std_logic_vector(15 downto 0);  -- Data for command FIFO
	BPI_WE            : out std_logic;                      -- Command FIFO write enable  (pulse one clock cycle for one write)
	BPI_RE            : out std_logic;                      -- Read back FIFO read enable  (pulse one clock cycle for one read)
	BPI_DSBL          : out std_logic;                      -- Disable parsing of BPI commands in the command FIFO (while being filled)
	BPI_ENBL          : out std_logic;                      -- Enable  parsing of BPI commands in the command FIFO
	BPI_RBK_FIFO_DATA : in std_logic_vector(15 downto 0); -- Data on output of the Read back FIFO
	BPI_RBK_WRD_CNT   : in std_logic_vector(10 downto 0); -- Word count of the Read back FIFO (number of available reads)
	BPI_STATUS        : in std_logic_vector(15 downto 0); -- FIFO status bits and latest value of the PROM status register. 
	BPI_TIMER         : in std_logic_vector(31 downto 0)  -- General timer

		
);
	
END COMPONENT;

COMPONENT ot_mgr
	PORT(
		 otx1_tx_en : OUT STD_LOGIC;
		 otx1_tx_dis : OUT STD_LOGIC;
		 otx1_reset : OUT STD_LOGIC;
		 otx1_fault : IN STD_LOGIC;
		 otx2_tx_en : OUT STD_LOGIC;
		 otx2_tx_dis : OUT STD_LOGIC;
		 otx2_reset : OUT STD_LOGIC;
		 otx2_fault : IN STD_LOGIC;
		 orx1_rx_en : OUT STD_LOGIC;
		 orx1_en_sd : OUT STD_LOGIC;
		 orx1_sd : IN STD_LOGIC;
		 orx1_sq_en : OUT STD_LOGIC;
		 orx2_rx_en : OUT STD_LOGIC;
		 orx2_en_sd : OUT STD_LOGIC;
		 orx2_sd : IN STD_LOGIC;
		 orx2_sq_en : OUT STD_LOGIC
	);
END COMPONENT;


-- Test Signals From/To J3

SIGNAL 	d_in, d_out, d_oe : STD_LOGIC_VECTOR(63 DOWNTO 0);		

-- BPI Prom signals

signal  bpi_rst : std_logic;
signal  vme_bpi_rst : std_logic;
signal  clk1mhz : std_logic;
signal  bpi_we : std_logic;
signal  bpi_re : std_logic;
signal  bpi_dsbl : std_logic;
signal  bpi_enbl : std_logic;
signal  bpi_busy : std_logic;
signal  bpi_load_data : std_logic;
signal  bpi_active : std_logic;
signal  bpi_execute : std_logic;
signal  bpi_cmd_fifo_data : std_logic_vector(15 downto 0);
signal  bpi_rbk_fifo_data : std_logic_vector(15 downto 0);
signal  bpi_rbk_wrd_cnt : std_logic_vector(10 downto 0);
signal  bpi_status : std_logic_vector(15 downto 0);
signal  bpi_timer : std_logic_vector(31 downto 0);
signal  bpi_data_from : std_logic_vector(15 downto 0);
signal  bpi_op : std_logic_vector(1 downto 0);
signal  bpi_addr : std_logic_vector(22 downto 0);
signal  bpi_data_to : std_logic_vector(15 downto 0);
signal  dual_data_leds : std_logic_vector(15 downto 0);

-- VME Signals

signal	vme_data_out : STD_LOGIC_VECTOR (15 downto 0);
signal	vme_data_in : STD_LOGIC_VECTOR (15 downto 0);
signal	vme_tovme_b : STD_LOGIC;
signal	vme_doe_b : STD_LOGIC; -- not used

-- To/From FIFOs

signal	dcfeb0_data, dcfeb0_fifo_in, dcfeb0_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb0_data_valid	: STD_LOGIC;
signal	dcfeb1_data, dcfeb1_fifo_in, dcfeb1_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb1_data_valid	: STD_LOGIC;
signal	dcfeb2_data, dcfeb2_fifo_in, dcfeb2_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb2_data_valid	: STD_LOGIC;
signal	dcfeb3_data, dcfeb3_fifo_in, dcfeb3_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb3_data_valid	: STD_LOGIC;
signal	dcfeb4_data, dcfeb4_fifo_in, dcfeb4_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb4_data_valid	: STD_LOGIC;
signal	dcfeb5_data, dcfeb5_fifo_in, dcfeb5_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb5_data_valid	: STD_LOGIC;
signal	dcfeb6_data, dcfeb6_fifo_in, dcfeb6_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb6_data_valid	: STD_LOGIC;
signal	dcfeb7_data, dcfeb7_fifo_in, dcfeb7_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb7_data_valid	: STD_LOGIC;
signal	tmb_data, tmb_fifo_in, tmb_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	tmb_data_valid	: STD_LOGIC;
signal	alct_data, alct_fifo_in, alct_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	alct_data_valid	: STD_LOGIC;

signal	fifo_mrst_b, fifo_prst_b : STD_LOGIC;
signal	fifo_wr_ck, fifo_rd_ck : STD_LOGIC;
signal	fifo_tm_wr_en, fifo_wr_en, fifo_rd_en : STD_LOGIC_VECTOR(9 downto 1);
signal	fifo_rw_en, fifo_rm_en, fifo_tm_en : STD_LOGIC_VECTOR (9 downto 1);
signal	fifo_full, fifo_half, fifo_pae, fifo_empty : STD_LOGIC_VECTOR (9 downto 1);		
signal	fifo_sel : STD_LOGIC_VECTOR (3 downto 0);														
signal	fifo_in, fifo_out : STD_LOGIC_VECTOR (17 downto 0);													
													
-- TTC Signals

signal	dl_jtag_tck, dl_jtag_tdo, dl_rtn_shft_en : STD_LOGIC_VECTOR(7 downto 1);				
signal	dl_jtag_tms, dl_jtag_tdi : STD_LOGIC;				
signal	ul_jtag_tck, ul_jtag_tms, ul_jtag_tdi : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_spi_cs0, dl_spi_cs1, dl_spi_scl, dl_spi_sda : STD_LOGIC_VECTOR(7 downto 1);				
signal	ul_spi_scl, ul_spi_sda, ul_spi_busy : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_tkn : STD_LOGIC_VECTOR(7 downto 1);				
signal	ul_tkn : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_i2c_scl, dl_i2c_sda : STD_LOGIC_VECTOR(7 downto 1);				
signal	ul_i2c_scl, ul_i2c_sda : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_injpulse, dl_extpulse, dl_gtrig : STD_LOGIC;
signal	dl_lct, dl_l1t : STD_LOGIC_VECTOR (7 downto 1);
signal	dl_global_rst : STD_LOGIC;
signal	dl_resync : STD_LOGIC_VECTOR(7 downto 1);
SIGNAL	dl_reprogram :  STD_LOGIC_VECTOR(7 downto 1);
SIGNAL	ul_dav, ul_movlp, ul_done : STD_LOGIC_VECTOR (7 downto 1);

-- Mode Selection Signals

signal	pb_reset, lb_en, lb_ff_en, tm_en : STD_LOGIC;





-- From/To OTs 

signal	otx1_01, otx1_02, otx1_03, otx1_04, otx1_05, otx1_06, otx1_07, otx1_08, otx1_09, otx1_10, otx1_11, otx1_12 : STD_LOGIC;
signal	otx2_01, otx2_02, otx2_03, otx2_04, otx2_05, otx2_06, otx2_07, otx2_08, otx2_09, otx2_10, otx2_11, otx2_12 : STD_LOGIC;
signal	orx1_01, orx1_02, orx1_03, orx1_04, orx1_05, orx1_06, orx1_07, orx1_08, orx1_09, orx1_10, orx1_11, orx1_12 : STD_LOGIC;
signal	orx2_01, orx2_02, orx2_03, orx2_04, orx2_05, orx2_06, orx2_07, orx2_08, orx2_09, orx2_10, orx2_11, orx2_12 : STD_LOGIC;

-- From/To Giga-Bit Links

signal 	gl0_tx, gl0_rx, gl1_tx, gl1_rx : STD_LOGIC;

signal	grx0_data : STD_LOGIC_VECTOR(15 DOWNTO 0) := "0000000000000000";									  
signal	grx0_data_valid : STD_LOGIC := '0';			 
signal	grx1_data : STD_LOGIC_VECTOR(15 DOWNTO 0) := "0000000000000000";												  
signal	grx1_data_valid : STD_LOGIC := '0';	 
	
signal	gtx0_data : STD_LOGIC_VECTOR(15 DOWNTO 0);										  
signal	gtx0_data_valid : STD_LOGIC;			 
signal	gtx1_data : STD_LOGIC_VECTOR(15 DOWNTO 0);											  
signal	gtx1_data_valid : STD_LOGIC;			 

-- From LVDS Test Connector

signal 	ck_0, ck_1, ck_2, clk, tx_0, tx_1, tx_2, tx_3, tx_4, tx_5, tx_6, tx_7, tx_8, tx_9, tx_10 : STD_LOGIC;
signal 	rxb, rx_0, rx_1, rx_2, rx_3, rx_4, rx_5, rx_6, rx_7, rx_8, rx_9, rx_10 : STD_LOGIC;


-- PLL Signals

signal	clkin, qpll_clk40MHz, qpll_clk80MHz, qpll_clk160MHz : STD_LOGIC;

SIGNAL 	pll1_fb, pll1_rst, pll1_pd, pll1_locked : STD_LOGIC;
SIGNAL 	pll2_fb, pll2_rst, pll2_pd, pll2_locked : STD_LOGIC;
SIGNAL 	pll3_fb, pll3_rst, pll3_pd, pll3_locked : STD_LOGIC;

signal 	pll_clk40, clk40 : STD_LOGIC;
signal 	pll_clk320_tx, clk320_tx : STD_LOGIC;
signal	pll_dmbvme_clk, dmbvme_clk : STD_LOGIC;				-- fpgaclk (40MHz)
signal 	pll_dmbvme_clk_s1, dmbvme_clk_s1 : STD_LOGIC;	-- midclk (10MHz) 
signal 	pll_dmbvme_clk_s2, dmbvme_clk_s2 : STD_LOGIC;	-- slowclk (2.5MHz)
-- bgb signal 	pll_dmbvme_clk_s3, dmbvme_clk_s3 : STD_LOGIC;	-- slowclk2 (1.25MHz)
signal 	dmbvme_clk_s3, dmbvme_clk_s3_b : STD_LOGIC;	-- slowclk2 (1.25MHz)
signal	clk125 : STD_LOGIC; -- reference clock for data transfers at 1 GbE rate.
signal   dummy_clk2 : STD_LOGIC;
signal   dummy_clk3 : STD_LOGIC;
signal   dummy_clk4 : STD_LOGIC;
signal   dummy_clk6 : STD_LOGIC;
signal   dummy_clk7 : STD_LOGIC;

signal 	pll_dcfeb0_clk320_tx, dcfeb0_clk320_tx, pll_dcfeb0_clk320_rx, dcfeb0_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb1_clk320_tx, dcfeb1_clk320_tx, pll_dcfeb1_clk320_rx, dcfeb1_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb2_clk320_tx, dcfeb2_clk320_tx, pll_dcfeb2_clk320_rx, dcfeb2_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb3_clk320_tx, dcfeb3_clk320_tx, pll_dcfeb3_clk320_rx, dcfeb3_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb4_clk320_tx, dcfeb4_clk320_tx, pll_dcfeb4_clk320_rx, dcfeb4_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb5_clk320_tx, dcfeb5_clk320_tx, pll_dcfeb5_clk320_rx, dcfeb5_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb6_clk320_tx, dcfeb6_clk320_tx, pll_dcfeb6_clk320_rx, dcfeb6_clk320_rx : STD_LOGIC;


-- Other signals

signal	iob_rsvtd_out : STD_LOGIC_VECTOR (7 downto 0);
signal	iob_rsvtd_in : STD_LOGIC_VECTOR (7 downto 0);

signal	por : STD_LOGIC;
signal	por_reg : STD_LOGIC_VECTOR (31 downto 0);

SIGNAL 	int_dl_jtag_tdo : STD_LOGIC_VECTOR(7 downto 1) := "0000000"; 
SIGNAL 	jtag_dr0 : STD_LOGIC_VECTOR(15 downto 0); 
SIGNAL 	jtag_ir : STD_LOGIC_VECTOR(10 downto 0); 

SIGNAL 	int_lvmb_pon : STD_LOGIC_VECTOR(7 downto 0); 
SIGNAL 	int_lvmb_adc_sdout : STD_LOGIC_VECTOR(6 downto 0); 
SIGNAL 	int_lvmb_csb : STD_LOGIC_VECTOR(6 downto 0); 
SIGNAL 	int_lvmb_sclk,int_lvmb_sdin : STD_LOGIC; 

SIGNAL 	leds_in : STD_LOGIC_VECTOR(11 downto 0); 

-- Test FIFO (DUALCLK)
signal	tmp_clk_out	: STD_LOGIC;
signal	tmp_clk_out2	: STD_LOGIC;
signal	dcfeb0_clk_ds_i	: STD_LOGIC;
signal	dcfeb0_gbrx_data : STD_LOGIC_VECTOR(15 downto 0);
signal	dcfeb0_gbrx_data_valid, dcfeb0_gbrx_data_clk	: STD_LOGIC;
signal	dcfeb0_tfifo_in, dcfeb0_tfifo_out : STD_LOGIC_VECTOR(15 downto 0);
signal	dcfeb0_fifo_wr_cnt, dcfeb0_fifo_rd_cnt : STD_LOGIC_VECTOR(9 downto 0);
signal	dcfeb0_fifo_wr_en, dcfeb0_fifo_wr_ck : STD_LOGIC;
signal	dcfeb0_fifo_rd_en, dcfeb0_fifo_rd_ck : STD_LOGIC;
signal	empty, a_empty, a_full, full, rderr, wrterr : STD_LOGIC_VECTOR(7 downto 0);
signal   fifo_rst : STD_LOGIC;

signal	adc_mask, dcfeb1t_adc_mask, dcfeb2t_adc_mask : STD_LOGIC_VECTOR(11 downto 0);


signal	diagout_cfebjtag  : std_logic_vector(17 downto 0);

signal	cdc_clk  : std_logic_vector(7 downto 0);


signal	csp_vme_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_fifo_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_cfeb_jtag_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_gtx_mac_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_gtx_vio_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_pkt_frm_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_bpi_vio_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_bpi_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal   vme_la_trg : STD_LOGIC; -- bgb logic analyzer trigger
signal	fifo_la_data : STD_LOGIC_VECTOR(127 downto 0); -- bgb ff_emu logic analyzer data signals
signal	fifo_la_trig : STD_LOGIC_VECTOR(7 downto 0); -- bgb ff_emu logic analyzer trigger signals


-- Test FIFO Signals

signal  tfifo_data : std_logic_vector(15 downto 0);
signal  tfifo_wc, tfifo_rc : std_logic_vector(11 downto 0);
signal  tfifo_str : std_logic_vector(15 downto 0);
signal  tfifo_wr_en : std_logic_vector(7 downto 0);
signal  tfifo_rd_en : std_logic_vector(7 downto 0);
signal  tfifo_sel : std_logic_vector(7 downto 0);
signal  tfifo_mode : std_logic;
signal  tfifo_rst : std_logic;


BEGIN 

-- bgb
-- bgb Need pullup on DTACK*
-- bgb 

PULLUP_dtack_b : PULLUP
   port map (O => vme_dtack_v6_b);


fd_clr <= '0';
fd_pre <= '1';

-- clkin <= ck_0;
clkin <= qpll_clk40MHz; -- for full speed operation

--
-- bgb added power on reset
--

process (dmbvme_clk_s2,pll1_locked)
begin
   if pll1_locked ='0' then 
      por_reg <= x"FFFFFFFF"; 
   elsif dmbvme_clk_s2'event and dmbvme_clk_s2='1' then  
		por_reg <= por_reg(30 downto 0) & '0';
   end if;
end process;
por <= por_reg(31);


-- bgb 
-- bgb  Added Chip Scope Pro Controller 
-- bgb 

--csp_control_j3_i : csp_control_j3_u4
--  port map (
--    CONTROL0 => csp_vme_la_ctrl,
--    CONTROL1 => csp_fifo_la_ctrl,
--    CONTROL2 => csp_cfeb_jtag_la_ctrl,
--    CONTROL3 => csp_gtx_mac_la_ctrl
--);
	 
--csp_control_j3_i : csp_control_j3_u5
--  port map (
--    CONTROL0 => csp_vme_la_ctrl,
--    CONTROL1 => csp_fifo_la_ctrl,
--    CONTROL2 => csp_cfeb_jtag_la_ctrl,
--    CONTROL3 => csp_gtx_mac_la_ctrl,
--    CONTROL4 => csp_pkt_frm_la_ctrl
--);

--csp_control_j3_i : csp_control_j3_u6
--  port map (
--    CONTROL0 => csp_vme_la_ctrl,
--    CONTROL1 => csp_fifo_la_ctrl,
--    CONTROL2 => csp_cfeb_jtag_la_ctrl,
--    CONTROL3 => csp_gtx_mac_la_ctrl,
--    CONTROL4 => csp_pkt_frm_la_ctrl,
--    CONTROL5 => csp_gtx_vio_ctrl
--);
	 
csp_control_j3_i : csp_control_j3_u7
  port map (
    CONTROL0 => csp_vme_la_ctrl,
    CONTROL1 => csp_fifo_la_ctrl,
    CONTROL2 => csp_cfeb_jtag_la_ctrl,
    CONTROL3 => csp_gtx_mac_la_ctrl,
    CONTROL4 => csp_pkt_frm_la_ctrl,
    CONTROL5 => csp_bpi_vio_ctrl,
    CONTROL6 => csp_bpi_la_ctrl
);

-- bgb 
-- bgb  Added Chip Scope Pro Logic analyzer for VME signal
-- bgb 


-- VME I/O Signals From/To J4 (vme_data)

vme_d00_buf : IOBUF port map (O => vme_data_in(0), IO => vme_data(0), I => vme_data_out(0), T => vme_tovme_b);     	
vme_d01_buf : IOBUF port map (O => vme_data_in(1), IO => vme_data(1), I => vme_data_out(1), T => vme_tovme_b);     	
vme_d02_buf : IOBUF port map (O => vme_data_in(2), IO => vme_data(2), I => vme_data_out(2), T => vme_tovme_b);     	
vme_d03_buf : IOBUF port map (O => vme_data_in(3), IO => vme_data(3), I => vme_data_out(3), T => vme_tovme_b);     	
vme_d04_buf : IOBUF port map (O => vme_data_in(4), IO => vme_data(4), I => vme_data_out(4), T => vme_tovme_b);     	
vme_d05_buf : IOBUF port map (O => vme_data_in(5), IO => vme_data(5), I => vme_data_out(5), T => vme_tovme_b);     	
vme_d06_buf : IOBUF port map (O => vme_data_in(6), IO => vme_data(6), I => vme_data_out(6), T => vme_tovme_b);     	
vme_d07_buf : IOBUF port map (O => vme_data_in(7), IO => vme_data(7), I => vme_data_out(7), T => vme_tovme_b);     	
vme_d08_buf : IOBUF port map (O => vme_data_in(8), IO => vme_data(8), I => vme_data_out(8), T => vme_tovme_b);     	
vme_d09_buf : IOBUF port map (O => vme_data_in(9), IO => vme_data(9), I => vme_data_out(9), T => vme_tovme_b);     	
vme_d10_buf : IOBUF port map (O => vme_data_in(10), IO => vme_data(10), I => vme_data_out(10), T => vme_tovme_b);     	
vme_d11_buf : IOBUF port map (O => vme_data_in(11), IO => vme_data(11), I => vme_data_out(11), T => vme_tovme_b);     	
vme_d12_buf : IOBUF port map (O => vme_data_in(12), IO => vme_data(12), I => vme_data_out(12), T => vme_tovme_b);     	
vme_d13_buf : IOBUF port map (O => vme_data_in(13), IO => vme_data(13), I => vme_data_out(13), T => vme_tovme_b);     	
vme_d14_buf : IOBUF port map (O => vme_data_in(14), IO => vme_data(14), I => vme_data_out(14), T => vme_tovme_b);     	
vme_d15_buf : IOBUF port map (O => vme_data_in(15), IO => vme_data(15), I => vme_data_out(15), T => vme_tovme_b);     	



-- Initial Assignments

lvmb_csb <= int_lvmb_csb;
lvmb_sclk <= int_lvmb_sclk;									
lvmb_sdin <= int_lvmb_sdin;									


leds_in(8) <= pb(0);
leds_in(9) <= pb(1);
leds_in(10) <= pb(2);
leds_in(11) <= pb(3);

--d_out(0) <= d_in(0);
--d_oe(0) <= '0';
d_out(0) <= diagout_cfebjtag(0); -- TP58
d_oe(0) <= '0';
d00_buf : IOBUF port map (O => d_in(0), IO => d(0), I => d_out(0), T => d_oe(0));     	

--d_out(1) <= d_in(1);
--d_oe(1) <= '0';
d_out(1) <= diagout_cfebjtag(1); -- TP60
d_oe(1) <= '0';
d01_buf : IOBUF port map (O => d_in(1), IO => d(1), I => d_out(1), T => d_oe(1));     	

--d_out(2) <= d_in(2);
--d_oe(2) <= '0';
d_out(2) <= diagout_cfebjtag(2); -- TP62
d_oe(2) <= '0';
d02_buf : IOBUF port map (O => d_in(2), IO => d(2), I => d_out(2), T => d_oe(2));     	

--d_out(3) <= d_in(3);
--d_oe(3) <= '0';
d_out(3) <= diagout_cfebjtag(3); -- TP64
d_oe(3) <= '0';
d03_buf : IOBUF port map (O => d_in(3), IO => d(3), I => d_out(3), T => d_oe(3));     	

--d_out(4) <= d_in(4);
--d_oe(4) <= '0';
d_out(4) <= diagout_cfebjtag(4); -- TP66
d_oe(4) <= '0';
d04_buf : IOBUF port map (O => d_in(4), IO => d(4), I => d_out(4), T => d_oe(4));     	

--d_out(5) <= d_in(5);
--d_oe(5) <= '0';
d_out(5) <= diagout_cfebjtag(5); -- TP68
d_oe(5) <= '1';
d05_buf : IOBUF port map (O => d_in(5), IO => d(5), I => d_out(5), T => d_oe(5));     	

--d_out(6) <= d_in(6);
--d_oe(6) <= '0';
d_out(6) <= diagout_cfebjtag(6); -- TP70
d_oe(6) <= '0';
d06_buf : IOBUF port map (O => d_in(6), IO => d(6), I => d_out(6), T => d_oe(6));     	

--d_out(7) <= d_in(7);
--d_oe(7) <= '0';
d_out(7) <= diagout_cfebjtag(7); -- TP72
d_oe(7) <= '0';
d07_buf : IOBUF port map (O => d_in(7), IO => d(7), I => d_out(7), T => d_oe(7));     	

--d_out(8) <= d_in(8);
--d_oe(8) <= '0';
d_out(8) <= diagout_cfebjtag(8); -- TP74
d_oe(8) <= '0';
d08_buf : IOBUF port map (O => d_in(8), IO => d(8), I => d_out(8), T => d_oe(8));     	

d_out(9) <= d_in(9);
d_oe(9) <= '0';
d09_buf : IOBUF port map (O => d_in(9), IO => d(9), I => d_out(9), T => d_oe(9));     	

d_out(10) <= d_in(10);
d_oe(10) <= '0';	
d10_buf : IOBUF port map (O => d_in(10), IO => d(10), I => d_out(10), T => d_oe(10));     	

d_out(11) <= d_in(11);
d_oe(11) <= '0';
d11_buf : IOBUF port map (O => d_in(11), IO => d(11), I => d_out(11), T => d_oe(11));     	

d_out(12) <= d_in(12);
d_oe(12) <= '0';		
d12_buf : IOBUF port map (O => d_in(12), IO => d(12), I => d_out(12), T => d_oe(12));     	

d_out(13) <= d_in(13);
d_oe(13) <= '0';	
d13_buf : IOBUF port map (O => d_in(13), IO => d(13), I => d_out(13), T => d_oe(13));     	

d_out(14) <= d_in(14);
d_oe(14) <= '0';	
d14_buf : IOBUF port map (O => d_in(14), IO => d(14), I => d_out(14), T => d_oe(14));     	

d_out(15) <= d_in(15);
d_oe(15) <= '0';	
d15_buf : IOBUF port map (O => d_in(15), IO => d(15), I => d_out(15), T => d_oe(15));     	

d_out(16) <= d_in(16);
d_oe(16) <= '0';		
d16_buf : IOBUF port map (O => d_in(16), IO => d(16), I => d_out(16), T => d_oe(16));     	

d_out(17) <= d_in(17);
d_oe(17) <= '0';		
d17_buf : IOBUF port map (O => d_in(17), IO => d(17), I => d_out(17), T => d_oe(17));     	

d_out(18) <= d_in(18);
d_oe(18) <= '0';	
d18_buf : IOBUF port map (O => d_in(18), IO => d(18), I => d_out(18), T => d_oe(18));     	

d_out(19) <= d_in(19);
d_oe(19) <= '0';	
d19_buf : IOBUF port map (O => d_in(19), IO => d(19), I => d_out(19), T => d_oe(19));     	

d_out(20) <= d_in(20);
d_oe(20) <= '0';	
d20_buf : IOBUF port map (O => d_in(20), IO => d(20), I => d_out(20), T => d_oe(20));     	

d_out(21) <= d_in(21);
d_oe(21) <= '0';	
d21_buf : IOBUF port map (O => d_in(21), IO => d(21), I => d_out(21), T => d_oe(21));     	

d_out(22) <= d_in(22);
d_oe(22) <= '0';		
d22_buf : IOBUF port map (O => d_in(22), IO => d(22), I => d_out(22), T => d_oe(22));     	

d_out(23) <= d_in(23);
d_oe(23) <= '0';		
d23_buf : IOBUF port map (O => d_in(23), IO => d(23), I => d_out(23), T => d_oe(23));     	

d_out(24) <= d_in(24);
d_oe(24) <= '0';		
d24_buf : IOBUF port map (O => d_in(24), IO => d(24), I => d_out(24), T => d_oe(24));     	

d_out(25) <= d_in(25);
d_oe(25) <= '0';		
d25_buf : IOBUF port map (O => d_in(25), IO => d(25), I => d_out(25), T => d_oe(25));     	

d_out(26) <= d_in(26);
d_oe(26) <= '0';		
d26_buf : IOBUF port map (O => d_in(26), IO => d(26), I => d_out(26), T => d_oe(26));     	

d_out(27) <= d_in(27);
d_oe(27) <= '0';		
d27_buf : IOBUF port map (O => d_in(27), IO => d(27), I => d_out(27), T => d_oe(27));     	

d_out(28) <= d_in(28);
d_oe(28) <= '0';	
d28_buf : IOBUF port map (O => d_in(28), IO => d(28), I => d_out(28), T => d_oe(28));     	

d_out(29) <= d_in(29);
d_oe(29) <= '0';	
d29_buf : IOBUF port map (O => d_in(29), IO => d(29), I => d_out(29), T => d_oe(29));     	

d_out(30) <= d_in(30);
d_oe(30) <= '0';	
d30_buf : IOBUF port map (O => d_in(30), IO => d(30), I => d_out(30), T => d_oe(30));     	

d_out(31) <= d_in(31);
d_oe(31) <= '0';	
d31_buf : IOBUF port map (O => d_in(31), IO => d(31), I => d_out(31), T => d_oe(31));     	

--d_out(32) <= d_in(32);
--d_oe(32) <= '0';	
d_out(32) <= diagout_cfebjtag(9); -- TP59
d_oe(32) <= '0';
d32_buf : IOBUF port map (O => d_in(32), IO => d(32), I => d_out(32), T => d_oe(32));     	

--d_out(33) <= d_in(33);
--d_oe(33) <= '0';		
d_out(33) <= diagout_cfebjtag(10); -- TP61
d_oe(33) <= '0';
d33_buf : IOBUF port map (O => d_in(33), IO => d(33), I => d_out(33), T => d_oe(33));     	

--d_out(34) <= d_in(34);
--d_oe(34) <= '0';	
d_out(34) <= diagout_cfebjtag(11); -- TP63
d_oe(34) <= '0';
d34_buf : IOBUF port map (O => d_in(34), IO => d(34), I => d_out(34), T => d_oe(34));     	

--d_out(35) <= d_in(35);
--d_oe(35) <= '0';		
d_out(35) <= diagout_cfebjtag(12); -- TP65
d_oe(35) <= '0';
d35_buf : IOBUF port map (O => d_in(35), IO => d(35), I => d_out(35), T => d_oe(35));     	

--d_out(36) <= d_in(36);
--d_oe(36) <= '0';	
d_out(36) <= diagout_cfebjtag(13); -- TP67
d_oe(36) <= '0';
d36_buf : IOBUF port map (O => d_in(36), IO => d(36), I => d_out(36), T => d_oe(36));     	

--d_out(37) <= d_in(37);
--d_oe(37) <= '0';	
d_out(37) <= diagout_cfebjtag(14); -- TP69
d_oe(37) <= '0';
d37_buf : IOBUF port map (O => d_in(37), IO => d(37), I => d_out(37), T => d_oe(37));     	

--d_out(38) <= d_in(38);
--d_oe(38) <= '0';	
d_out(38) <= diagout_cfebjtag(15); -- TP71
d_oe(38) <= '0';
d38_buf : IOBUF port map (O => d_in(38), IO => d(38), I => d_out(38), T => d_oe(38));     	

--d_out(39) <= d_in(39);
--d_oe(39) <= '0';	
d_out(39) <= diagout_cfebjtag(16); -- TP73
d_oe(39) <= '0';
d39_buf : IOBUF port map (O => d_in(39), IO => d(39), I => d_out(39), T => d_oe(39));     	

--d_out(40) <= d_in(40);
--d_oe(40) <= '0';		
d_out(40) <= diagout_cfebjtag(17); -- TP75
d_oe(40) <= '0';
d40_buf : IOBUF port map (O => d_in(40), IO => d(40), I => d_out(40), T => d_oe(40));     	

d_out(41) <= d_in(41);
d_oe(41) <= '0';		
d41_buf : IOBUF port map (O => d_in(41), IO => d(41), I => d_out(41), T => d_oe(41));     	

d_out(42) <= d_in(42);
d_oe(42)  <= '0';	
d42_buf : IOBUF port map (O => d_in(42), IO => d(42), I => d_out(42), T => d_oe(42));     	

d_out(43) <= d_in(43);
d_oe(43)  <= '0';	
d43_buf : IOBUF port map (O => d_in(43), IO => d(43), I => d_out(43), T => d_oe(43));     	

d_out(44) <= d_in(44);
d_oe(44)  <= '0';		
d44_buf : IOBUF port map (O => d_in(44), IO => d(44), I => d_out(44), T => d_oe(44));     	

d_out(45) <= d_in(45);
d_oe(45)  <= '0';		
d45_buf : IOBUF port map (O => d_in(45), IO => d(45), I => d_out(45), T => d_oe(45));     	

d_out(46) <= d_in(46);
d_oe(46)  <= '0';		
d46_buf : IOBUF port map (O => d_in(46), IO => d(46), I => d_out(46), T => d_oe(46));     	

d_out(47) <= d_in(47);
d_oe(47)  <= '0';		
d47_buf : IOBUF port map (O => d_in(47), IO => d(47), I => d_out(47), T => d_oe(47));     	

d_out(48) <= d_in(48);
d_oe(48)  <= '0';		
d48_buf : IOBUF port map (O => d_in(48), IO => d(48), I => d_out(48), T => d_oe(48));     	

d_out(49) <= d_in(49);
d_oe(49)  <= '0';		
d49_buf : IOBUF port map (O => d_in(49), IO => d(49), I => d_out(49), T => d_oe(49));     	

d_out(50) <= d_in(50);
d_oe(50)  <= '0';		
d50_buf : IOBUF port map (O => d_in(50), IO => d(50), I => d_out(50), T => d_oe(50));     	

d_out(51) <= d_in(51);
d_oe(51)  <= '0';		
d51_buf : IOBUF port map (O => d_in(51), IO => d(51), I => d_out(51), T => d_oe(51));     	

d_out(52) <= d_in(52);
d_oe(52)  <= '0';		
d52_buf : IOBUF port map (O => d_in(52), IO => d(52), I => d_out(52), T => d_oe(52));     	

d_out(53) <= d_in(53);
d_oe(53)  <= '0';	
d53_buf : IOBUF port map (O => d_in(53), IO => d(53), I => d_out(53), T => d_oe(53));     	

d_out(54) <= d_in(54);
d_oe(54)  <= '0';		
d54_buf : IOBUF port map (O => d_in(54), IO => d(54), I => d_out(54), T => d_oe(54));     	

d_out(55) <= d_in(55);
d_oe(55)  <= '0';		
d55_buf : IOBUF port map (O => d_in(55), IO => d(55), I => d_out(55), T => d_oe(55));     	

d_out(56) <= d_in(56);
d_oe(56)  <= '0';		
d56_buf : IOBUF port map (O => d_in(56), IO => d(56), I => d_out(56), T => d_oe(56));     	

d_out(57) <= d_in(57);
d_oe(57)  <= '0';	
d57_buf : IOBUF port map (O => d_in(57), IO => d(57), I => d_out(57), T => d_oe(57));     	

d_out(58) <= d_in(58);
d_oe(58)  <= '0';		
d58_buf : IOBUF port map (O => d_in(58), IO => d(58), I => d_out(58), T => d_oe(58));     	

d_out(59) <= d_in(59);
d_oe(59)  <= '0';		
d59_buf : IOBUF port map (O => d_in(59), IO => d(59), I => d_out(59), T => d_oe(59));     	

d_out(60) <= d_in(60);
d_oe(60)  <= '0';		
d60_buf : IOBUF port map (O => d_in(60), IO => d(60), I => d_out(60), T => d_oe(60));     	

d_out(61) <= d_in(61);
d_oe(61)  <= '0';		
d61_buf : IOBUF port map (O => d_in(61), IO => d(61), I => d_out(61), T => d_oe(61));     	

d_out(62) <= d_in(62);
d_oe(62)  <= '0';	
d62_buf : IOBUF port map (O => d_in(62), IO => d(62), I => d_out(62), T => d_oe(62));     	

d_out(63) <= d_in(63);
d_oe(63)  <= '0';	
d63_buf : IOBUF port map (O => d_in(63), IO => d(63), I => d_out(63), T => d_oe(63));     	

-- FW Version Jun_28_01

-- leds(11 downto 0) <= test_vme_data_in(11 downto 0);

leds_in(7 downto 0) <= int_lvmb_pon(7 downto 0);
lvmb_pon <= int_lvmb_pon(7 downto 0);

led00_buf : OBUF port map (O => leds(0), I => leds_in(0));    	
led01_buf : OBUF port map (O => leds(1), I => leds_in(1));    	
led02_buf : OBUF port map (O => leds(2), I => leds_in(2));    	
led03_buf : OBUF port map (O => leds(3), I => leds_in(3));    	
led04_buf : OBUF port map (O => leds(4), I => leds_in(4));    	
led05_buf : OBUF port map (O => leds(5), I => leds_in(5));    	
led06_buf : OBUF port map (O => leds(6), I => leds_in(6));    	
led07_buf : OBUF port map (O => leds(7), I => leds_in(7));    	
led08_buf : OBUF port map (O => leds(8), I => leds_in(8));    	
led09_buf : OBUF port map (O => leds(9), I => leds_in(9));    	
led10_buf : OBUF port map (O => leds(10), I => leds_in(10));    	
led11_buf : OBUF port map (O => leds(11), I => leds_in(11));    	

-- LVDS input buffers

-- From OT1 (GigaBit Link)

-- gl1_rx
gl1_rx_buf : IBUFDS port map (I=>gl0_rx_p, IB=>gl0_rx_n, O=>gl0_rx);

-- From OT2 (GigaBit Link)

-- gl2_rx
gl2_rx_buf : IBUFDS port map (I=>gl1_rx_p, IB=>gl1_rx_n, O=>gl1_rx);


-- From ORX1

-- orx1_01
orx1_01_buf : IBUFDS port map (I=>orx1_01_p, IB=>orx1_01_n, O=>orx1_01);
-- orx1_02
orx1_02_buf : IBUFDS port map (I=>orx1_02_p, IB=>orx1_02_n, O=>orx1_02);
-- orx1_03
orx1_03_buf : IBUFDS port map (I=>orx1_03_p, IB=>orx1_03_n, O=>orx1_03);
-- orx1_04
orx1_04_buf : IBUFDS port map (I=>orx1_04_p, IB=>orx1_04_n, O=>orx1_04);
-- orx1_05
orx1_05_buf : IBUFDS port map (I=>orx1_05_p, IB=>orx1_05_n, O=>orx1_05);
-- orx1_06
orx1_06_buf : IBUFDS port map (I=>orx1_06_p, IB=>orx1_06_n, O=>orx1_06);
-- orx1_07
orx1_07_buf : IBUFDS port map (I=>orx1_07_p, IB=>orx1_07_n, O=>orx1_07);
-- orx1_08
orx1_08_buf : IBUFDS port map (I=>orx1_08_p, IB=>orx1_08_n, O=>orx1_08);
-- orx1_09
orx1_09_buf : IBUFDS port map (I=>orx1_09_p, IB=>orx1_09_n, O=>orx1_09);
-- orx1_10
orx1_10_buf : IBUFDS port map (I=>orx1_10_p, IB=>orx1_10_n, O=>orx1_10);
-- orx1_11
orx1_11_buf : IBUFDS port map (I=>orx1_11_p, IB=>orx1_11_n, O=>orx1_11);
-- orx1_12
orx1_12_buf : IBUFDS port map (I=>orx1_12_p, IB=>orx1_12_n, O=>orx1_12);



-- From QPLL

-- qpll_clk40MHz
qpll_clk40MHz_buf : IBUFDS port map (I=>qpll_clk40MHz_p, IB=>qpll_clk40MHz_n, O=>qpll_clk40MHz);
-- qpll_clk80MHz
qpll_clk80MHz_buf : IBUFDS port map (I=>qpll_clk80MHz_p, IB=>qpll_clk80MHz_n, O=>qpll_clk80MHz);


-- From Test Connector

-- ck_0
ck_0_buf : IBUFDS port map (I=>ck_0_p, IB=>ck_0_n, O=>ck_0);
-- ck_1
ck_1_buf : IBUFDS port map (I=>ck_1_p, IB=>ck_1_n, O=>ck_1);
-- tclk
tclk_buf : IBUFDS port map (I=>tclk_p, IB=>tclk_n, O=>ck_2);

-- rx_0
rx_0_buf : IBUFDS port map (I=>rx_0_p, IB=>rx_0_n, O=>rx_0);
-- rx_1
rx_1_buf : IBUFDS port map (I=>rx_1_p, IB=>rx_1_n, O=>rx_1);
-- rx_2
rx_2_buf : IBUFDS port map (I=>rx_2_p, IB=>rx_2_n, O=>rx_2);
-- rx_3
rx_3_buf : IBUFDS port map (I=>rx_3_p, IB=>rx_3_n, O=>rx_3);
-- rx_4
rx_4_buf : IBUFDS port map (I=>rx_4_p, IB=>rx_4_n, O=>rx_4);
-- rx_5
rx_5_buf : IBUFDS port map (I=>rx_5_p, IB=>rx_5_n, O=>rx_5);
-- rx_6
rx_6_buf : IBUFDS port map (I=>rx_6_p, IB=>rx_6_n, O=>rx_6);
-- rx_7
rx_7_buf : IBUFDS port map (I=>rx_7_p, IB=>rx_7_n, O=>rx_7);
-- rx_8
rx_8_buf : IBUFDS port map (I=>rx_8_p, IB=>rx_8_n, O=>rx_8);
-- rx_9
rx_9_buf : IBUFDS port map (I=>rx_9_p, IB=>rx_9_n, O=>rx_9);
-- rx_10
rx_10_buf : IBUFDS port map (I=>rx_10_p, IB=>rx_10_n, O=>rx_10);


-- LVDS output buffers

-- To OT1 (GigaBit Link)

-- gl1_tx
gl1_tx_buf : OBUFDS port map (I=>gl0_tx, O=>gl0_tx_p, OB=>gl0_tx_n);


-- To OT2 (GigaBit Link)

-- gl2_tx
gl2_tx_buf : OBUFDS port map (I=>gl1_tx, O=>gl1_tx_p, OB=>gl1_tx_n);


-- To TX1 

-- otx1_01
otx1_01_buf : OBUFDS port map (I=>otx1_01, O=>otx1_01_p, OB=>otx1_01_n);
-- otx1_02
otx1_02_buf : OBUFDS port map (I=>otx1_02, O=>otx1_02_p, OB=>otx1_02_n);
-- otx1_03
otx1_03_buf : OBUFDS port map (I=>otx1_03, O=>otx1_03_p, OB=>otx1_03_n);
-- otx1_04
otx1_04_buf : OBUFDS port map (I=>otx1_04, O=>otx1_04_p, OB=>otx1_04_n);
-- otx1_05
otx1_05_buf : OBUFDS port map (I=>otx1_05, O=>otx1_05_p, OB=>otx1_05_n);
-- otx1_06
otx1_06_buf : OBUFDS port map (I=>otx1_06, O=>otx1_06_p, OB=>otx1_06_n);
-- otx1_07
otx1_07_buf : OBUFDS port map (I=>otx1_07, O=>otx1_07_p, OB=>otx1_07_n);
-- otx1_08
otx1_08_buf : OBUFDS port map (I=>otx1_08, O=>otx1_08_p, OB=>otx1_08_n);
-- otx1_09
otx1_09_buf : OBUFDS port map (I=>otx1_09, O=>otx1_09_p, OB=>otx1_09_n);
-- otx1_10
otx1_10_buf : OBUFDS port map (I=>otx1_10, O=>otx1_10_p, OB=>otx1_10_n);
-- otx1_11
otx1_11_buf : OBUFDS port map (I=>otx1_11, O=>otx1_11_p, OB=>otx1_11_n);
-- otx1_12
otx1_12_buf : OBUFDS port map (I=>otx1_12, O=>otx1_12_p, OB=>otx1_12_n);

-- To TX2 

-- otx2_01
otx2_01_buf : OBUFDS port map (I=>otx2_01, O=>otx2_01_p, OB=>otx2_01_n);
-- otx2_02
otx2_02_buf : OBUFDS port map (I=>otx2_02, O=>otx2_02_p, OB=>otx2_02_n);
-- otx2_03
otx2_03_buf : OBUFDS port map (I=>otx2_03, O=>otx2_03_p, OB=>otx2_03_n);
-- otx2_04
otx2_04_buf : OBUFDS port map (I=>otx2_04, O=>otx2_04_p, OB=>otx2_04_n);
-- otx2_05
otx2_05_buf : OBUFDS port map (I=>otx2_05, O=>otx2_05_p, OB=>otx2_05_n);
-- otx2_06
otx2_06_buf : OBUFDS port map (I=>otx2_06, O=>otx2_06_p, OB=>otx2_06_n);
-- otx2_07
otx2_07_buf : OBUFDS port map (I=>otx2_07, O=>otx2_07_p, OB=>otx2_07_n);
-- otx2_08
otx2_08_buf : OBUFDS port map (I=>otx2_08, O=>otx2_08_p, OB=>otx2_08_n);
-- otx2_09
otx2_09_buf : OBUFDS port map (I=>otx2_09, O=>otx2_09_p, OB=>otx2_09_n);
-- otx2_10
otx2_10_buf : OBUFDS port map (I=>otx2_10, O=>otx2_10_p, OB=>otx2_10_n);
-- otx2_11
otx2_11_buf : OBUFDS port map (I=>otx2_11, O=>otx2_11_p, OB=>otx2_11_n);
-- otx2_12
otx2_12_buf : OBUFDS port map (I=>otx2_12, O=>otx2_12_p, OB=>otx2_12_n);


-- To Test Connector

-- rxb
rxb_buf : OBUFDS port map (I=>rxb, O=>rxb_p, OB=>rxb_n);
-- tx_0
tx_0_buf : OBUFDS port map (I=>tx_0, O=>tx_0_p, OB=>tx_0_n);
-- tx_1
tx_1_buf : OBUFDS port map (I=>tx_1, O=>tx_1_p, OB=>tx_1_n);
-- tx_2
tx_2_buf : OBUFDS port map (I=>tx_2, O=>tx_2_p, OB=>tx_2_n);
-- tx_1
tx_3_buf : OBUFDS port map (I=>tx_3, O=>tx_3_p, OB=>tx_3_n);
-- tx_1
tx_4_buf : OBUFDS port map (I=>tx_4, O=>tx_4_p, OB=>tx_4_n);
-- tx_1
tx_5_buf : OBUFDS port map (I=>tx_5, O=>tx_5_p, OB=>tx_5_n);
-- tx_1
tx_6_buf : OBUFDS port map (I=>tx_6, O=>tx_6_p, OB=>tx_6_n);
-- tx_1
tx_7_buf : OBUFDS port map (I=>tx_7, O=>tx_7_p, OB=>tx_7_n);
-- tx_1
tx_8_buf : OBUFDS port map (I=>tx_8, O=>tx_8_p, OB=>tx_8_n);
-- tx_1
tx_9_buf : OBUFDS port map (I=>tx_9, O=>tx_9_p, OB=>tx_9_n);
-- tx_1
tx_10_buf : OBUFDS port map (I=>tx_10, O=>tx_10_p, OB=>tx_10_n);

  IBUFGDS_CDC_CLK_0 : IBUFGDS
   generic map (
      DIFF_TERM => TRUE, -- Differential Termination 
      IBUF_LOW_PWR => TRUE, -- Low power (TRUE) vs. performance (FALSE) setting for refernced I/O standards
      IOSTANDARD => "DEFAULT")
   port map (
      O => cdc_clk(0),  
      I => cdc_clk_0_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_0_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

  IBUFGDS_CDC_CLK_1 : IBUFGDS
   generic map (
      DIFF_TERM => TRUE, -- Differential Termination 
      IBUF_LOW_PWR => TRUE, -- Low power (TRUE) vs. performance (FALSE) setting for refernced I/O standards
      IOSTANDARD => "DEFAULT")
   port map (
      O => cdc_clk(1),  -- Clock buffer output
      I => cdc_clk_1_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_1_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

  IBUFGDS_CDC_CLK_2 : IBUFDS_GTXE1
   port map (
      O => cdc_clk(2),  -- Clock buffer output
      ODIV2 => open, 
      CEB => '0',  
      I => cdc_clk_2_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_2_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

  IBUFGDS_CDC_CLK_3 : IBUFDS_GTXE1
   port map (
      O => cdc_clk(3),  -- Clock buffer output
      ODIV2 => open, 
      CEB => '0',  
      I => cdc_clk_3_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_3_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

  IBUFGDS_CDC_CLK_4 : IBUFDS_GTXE1
   port map (
      O => cdc_clk(4),  -- Clock buffer output
      ODIV2 => open, 
      CEB => '0',  
      I => cdc_clk_4_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_4_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

  IBUFGDS_CDC_CLK_5 : IBUFDS_GTXE1
   port map (
      O => cdc_clk(5),  -- Clock buffer output
      ODIV2 => open, 
      CEB => '0',  
      I => cdc_clk_5_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_5_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

  IBUFGDS_CDC_CLK_6 : IBUFDS_GTXE1
   port map (
      O => cdc_clk(6),  -- Clock buffer output
      ODIV2 => open, 
      CEB => '0',  
      I => cdc_clk_6_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_6_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

  IBUFGDS_CDC_CLK_7 : IBUFDS_GTXE1
   port map (
      O => cdc_clk(7),  -- Clock buffer output
      ODIV2 => open, 
      CEB => '0',  
      I => cdc_clk_7_p,  -- Diff_p clock buffer input (connect directly to top-level port)
      IB => cdc_clk_7_n -- Diff_n clock buffer input (connect directly to top-level port)
   );

pll1_rst <= '0';
pll1_pd <= '0';
pll2_rst <= '0';
pll2_pd <= '0';
pll3_rst <= '0';
pll3_pd <= '0';


   MMCM_BASE_PLL1 : MMCM_BASE
   generic map (
      BANDWIDTH => "OPTIMIZED",  -- Jitter programming ("HIGH","LOW","OPTIMIZED")
      CLKFBOUT_MULT_F => 16.0,    -- Multiply value for all CLKOUT (5.0-64.0).
      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB (0.00-360.00).
      CLKIN1_PERIOD => 25.0,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
-- bgb      CLKOUT0_DIVIDE_F => 2.0,   -- Divide amount for CLKOUT0 (1.000-128.000).
      CLKOUT0_DIVIDE_F => 16.0,   -- Divide amount for CLKOUT0 (1.000-128.000).
      -- CLKOUT0_DUTY_CYCLE - CLKOUT6_DUTY_CYCLE: Duty cycle for each CLKOUT (0.01-0.99).
      CLKOUT0_DUTY_CYCLE => 0.5,
      CLKOUT1_DUTY_CYCLE => 0.5,
      CLKOUT2_DUTY_CYCLE => 0.5,
      CLKOUT3_DUTY_CYCLE => 0.5,
      CLKOUT4_DUTY_CYCLE => 0.5,
      CLKOUT5_DUTY_CYCLE => 0.5,
      CLKOUT6_DUTY_CYCLE => 0.5,
      -- CLKOUT0_PHASE - CLKOUT6_PHASE: Phase offset for each CLKOUT (-360.000-360.000).
      CLKOUT0_PHASE => 0.0,
      CLKOUT1_PHASE => 0.0,
      CLKOUT2_PHASE => 0.0,
      CLKOUT3_PHASE => 0.0,
      CLKOUT4_PHASE => 0.0,
      CLKOUT5_PHASE => 0.0,
      CLKOUT6_PHASE => 0.0,
      -- CLKOUT1_DIVIDE - CLKOUT6_DIVIDE: Divide amount for each CLKOUT (1-128)
-- bgb     CLKOUT1_DIVIDE => 16,
-- bgb     CLKOUT2_DIVIDE => 2,
-- bgb     CLKOUT3_DIVIDE => 16,
-- bgb     CLKOUT4_DIVIDE => 64,
-- bgb     CLKOUT5_DIVIDE => 128, --- 256,
-- bgb     CLKOUT6_DIVIDE => 128, --- 512,
      CLKOUT1_DIVIDE => 2, -- 320 MHz
      CLKOUT2_DIVIDE => 16, -- 40 MHz
      CLKOUT3_DIVIDE => 64, -- 10 MHz
      CLKOUT4_DIVIDE => 2,  --  2.5 MHz
      CLKOUT5_DIVIDE => 128, -- 5 MHz
      CLKOUT6_DIVIDE => 128, -- 5 MHz
-- bgb     CLKOUT4_CASCADE => FALSE,  -- Cascase CLKOUT4 counter with CLKOUT6 (TRUE/FALSE)
      CLKOUT4_CASCADE => TRUE,  -- Cascase CLKOUT4 counter with CLKOUT6 (TRUE/FALSE)
      CLOCK_HOLD => FALSE,       -- Hold VCO Frequency (TRUE/FALSE)
      DIVCLK_DIVIDE => 1,        -- Master division value (1-80)
      REF_JITTER1 => 0.0,        -- Reference input jitter in UI (0.000-0.999).
      STARTUP_WAIT => FALSE      -- Not supported. Must be set to FALSE.
   )
   port map (
      -- Clock Outputs: 1-bit (each) User configurable clock outputs
      CLKOUT0 => pll_clk40,     			-- 1-bit CLKOUT0 output
      CLKOUT0B => open,   					-- 1-bit Inverted CLKOUT0 output
      CLKOUT1 => pll_clk320_tx,     	-- 1-bit CLKOUT1 output
      CLKOUT1B => open,   					-- 1-bit Inverted CLKOUT1 output
      CLKOUT2 => pll_dmbvme_clk,    	-- 1-bit CLKOUT2 output
      CLKOUT2B => open,   					-- 1-bit Inverted CLKOUT2 output
      CLKOUT3 => pll_dmbvme_clk_s1,    -- 1-bit CLKOUT3 output
      CLKOUT3B => open,   					-- 1-bit Inverted CLKOUT3 output
      CLKOUT4 => pll_dmbvme_clk_s2,    -- 1-bit CLKOUT4 output
-- bgb      CLKOUT5 => pll_dmbvme_clk_s3,    -- 1-bit CLKOUT5 output
      CLKOUT5 => open,    -- 1-bit CLKOUT5 output
      CLKOUT6 => open,      				-- 1-bit CLKOUT6 output
      -- Feedback Clocks: 1-bit (each) Clock feedback ports
      CLKFBOUT => pll1_fb,   				-- 1-bit Feedback clock output
      CLKFBOUTB => open, 					-- 1-bit Inverted CLKFBOUT output
      -- Status Port: 1-bit (each) MMCM status ports
      LOCKED => pll1_locked,  			-- 1-bit LOCK output
      -- Clock Input: 1-bit (each) Clock input
      CLKIN1 => clkin, -- qpll_clk40MHz,
      -- Control Ports: 1-bit (each) MMCM control ports
      PWRDWN => pll1_pd,       			-- 1-bit Power-down input
      RST => pll1_rst,             		-- 1-bit Reset input
      -- Feedback Clocks: 1-bit (each) Clock feedback ports
      CLKFBIN => pll1_fb      			-- 1-bit Feedback clock input
   );


clk40_buf : BUFG port map (I=>pll_clk40, O=>clk40);
clk320_tx_buf : BUFG port map (I=>pll_clk320_tx, O=>clk320_tx);
dmbvme_clk_buf : BUFG port map (I=>pll_dmbvme_clk, O=>dmbvme_clk);
dmbvme_clk_s1_buf : BUFG port map (I=>pll_dmbvme_clk_s1, O=>dmbvme_clk_s1);
dmbvme_clk_s2_buf : BUFG port map (I=>pll_dmbvme_clk_s2, O=>dmbvme_clk_s2);
-- bgb dmbvme_clk_s3_buf : BUFG port map (I=>pll_dmbvme_clk_s3, O=>dmbvme_clk_s3);
   dmbvme_clk_s3_b <= not dmbvme_clk_s3;
    FD(dmbvme_clk_s3_b,dmbvme_clk_s2,dmbvme_clk_s3); -- 1.25 MHz clock (bgb)


clk125_mmcm_inst : clk125_mmcm
  port map
   (-- Clock in ports
    CLK_IN1            => clkin,
    -- Clock out ports
    CLK_OUT1           => clk125,
    CLK_OUT2           => dummy_clk2,
    CLK_OUT3           => dummy_clk3,
    CLK_OUT4           => dummy_clk4,
    CLK_OUT5           => clk1mhz,
    CLK_OUT6           => dummy_clk6,
    CLK_OUT7           => dummy_clk7);

--otx2_01 <= dcfeb0_clk320_tx;
--otx2_02 <= dcfeb1_clk320_tx;
--otx2_03 <= dcfeb2_clk320_tx;
--otx2_04 <= dcfeb3_clk320_tx;
--otx2_05 <= dcfeb4_clk320_tx;
--otx2_06 <= dcfeb5_clk320_tx;
--otx2_07 <= dcfeb6_clk320_tx;
otx2_01 <= clk320_tx;
otx2_02 <= clk320_tx;
otx2_03 <= clk320_tx;
otx2_04 <= clk320_tx;
otx2_05 <= clk320_tx;
otx2_06 <= clk320_tx;
otx2_07 <= clk320_tx;
otx2_08 <= '0';
otx2_09 <= '0';
otx2_10 <= '0'; 
otx2_11 <= '0'; 
otx2_12 <= '0'; 
 
otx1_01 <= '0'; 	-- in the LoopBack Configuration otx1_01 is driven by dcfebx_tx_dat   
otx1_02 <= '0'; 
otx1_03 <= '0'; 
otx1_04 <= '0'; 
otx1_05 <= '0'; 
otx1_06 <= '0'; 
otx1_07 <= '0'; 
otx1_08 <= '0';
 otx1_09 <= '0';
 otx1_10 <= '0'; 
otx1_11 <= '0'; 
 otx1_12 <= '0';

--dcfeb0_rx_dat <= orx1_01;
-- dcfeb1_rx_dat <= orx1_02; 	
-- dcfeb2_rx_dat <= orx1_03;
--dcfeb3_rx_dat <= orx1_04;
--dcfeb4_rx_dat <= orx1_05;
--dcfeb5_rx_dat <= orx1_06;
--dcfeb6_rx_dat <= orx1_07;

b2v_mbv : dmb_vme
PORT MAP (

-- Chip Scope Pro Logic Analyzer control -- bgb

    CSP_VME_LA_CTRL       => csp_vme_la_ctrl,       -- bgb -- inout
    CSP_CFEB_JTAG_LA_CTRL => csp_cfeb_jtag_la_ctrl, -- bgb -- inout
	 VME_LA_TRG => vme_la_trg,                       -- bgb

-- VME signals 

		vme_addr => vme_addr,									-- input
		vme_data_in => vme_data_in,							-- input
		vme_data_out => vme_data_out,							-- output
		vme_am => vme_am,											-- input
		vme_gap => vme_gap,										-- input
		vme_ga => vme_ga,											-- input
		vme_ds_b => vme_ds_b,									-- input
		vme_as_b => vme_as_b,									-- input
		vme_lword_b => vme_lword_b,							-- input
		vme_write_b => vme_write_b,							-- input
		vme_iack_b => vme_iack_b,								-- input
		vme_sysreset_b => vme_sysreset_b,					-- input
		vme_sysfail_b => vme_sysfail_b,						-- input
		vme_sysfail_out => vme_sysfail_out,				-- output
		vme_berr_b => vme_berr_b,								-- input
		vme_berr_out => vme_berr_out,						-- output
		vme_dtack_b => vme_dtack_v6_b,							-- output
		vme_tovme => vme_tovme,										-- tovme
		vme_tovme_b => vme_tovme_b,										-- tovme*
		vme_doe => vme_doe,									-- doe
		vme_doe_b => vme_doe_b,									-- doe*

-- Clock

		clk => dmbvme_clk,											-- fpgaclk (40MHz)
		clk_s1 => dmbvme_clk_s1,									-- midclk (10MHz) 
		clk_s2 => dmbvme_clk_s2,									-- slowclk (2.5MHz)
		clk_s3 => dmbvme_clk_s3, 									-- slowclk2 (1.25MHz)

-- Reset

		rst => por,
		
-- JTAG signals To/From DCFEBs

		dl_jtag_tck => dl_jtag_tck,			
		dl_jtag_tms => dl_jtag_tms,					
		dl_jtag_tdi => dl_jtag_tdi,						
		dl_jtag_tdo => "0000000",					
		dl_rtn_shft_en => "0000000",
		ul_jtag_tck => "0000000",					
		ul_jtag_tms => "0000000",				
		ul_jtag_tdi => "0000000",						

-- Reprogram To DCFEB FPGA (CFEBPRG)

		dl_reprogram => dl_reprogram,

-- Done from DCFEB FPGA (CFEBPRG)

		ul_done => ul_done,

-- To/From O-DMB ADC

		adc_cs => adc_cs,									
		adc_sclk =>	adc_sclk,								
		adc_sdain => adc_sdain,								
		adc_sdaout => adc_sdaout,							
		
-- To/From O-DMB DAC

		dac_cs => dac_cs,								
		dac_sclk => dac_sclk,										
		dac_sdain => dac_sdain,									
		dac_sdaout => dac_sdaout,										

-- To/From DCFEB FIFOs

		fifo_wr_ck => fifo_wr_ck,
		fifo_wr_en => fifo_tm_wr_en,	
		fifo_rw_en => fifo_rw_en,	
		fifo_rm_en => fifo_rm_en,	
		fifo_tm_en => fifo_tm_en,	

		fifo_in => fifo_in,
		fifo_out => fifo_out,

-- SPI signals To/From DCFEBs (ADCs and DACs)

		dl_spi_cs0 => dl_spi_cs0,
		dl_spi_cs1 => dl_spi_cs1,		
		dl_spi_scl => dl_spi_scl,			
		dl_spi_sda => dl_spi_sda,		 
		ul_spi_scl => ul_spi_scl,	
		ul_spi_sda => ul_spi_sda,	 
		ul_spi_busy => ul_spi_busy,		 

-- Token signals To/From DCFEBs

		dl_tkn => dl_tkn,				
		ul_tkn => ul_tkn,				

-- I2C signals To/From DCFEBs (FF-EMU ASICs)

		dl_i2c_scl => dl_i2c_scl,				
		dl_i2c_sda => dl_i2c_sda,				
		ul_i2c_scl => ul_i2c_scl,				
		ul_i2c_sda => ul_i2c_sda,			

-- From/To QPLL

		qpll_autorestart => qpll_autorestart,						-- NEW!
		qpll_mode => qpll_mode,											-- NEW!
		qpll_extcontrol => qpll_extcontrol,							-- NEW!
		qpll_reset => qpll_reset,										-- NEW!
		qpll_f0sel => qpll_f0sel,										-- NEW!
		qpll_locked => qpll_locked,									-- NEW!
		qpll_error => qpll_error,										-- NEW!

-- From/To LVMB

		lvmb_pon => int_lvmb_pon,
		pon_load => pon_load,
		pon_oe_b => pon_en,
		r_lvmb_pon => r_lvmb_pon,		
		lvmb_csb => int_lvmb_csb,			
		lvmb_sclk => int_lvmb_sclk,
		lvmb_sdin => int_lvmb_sdin,			
		lvmb_sdout => lvmb_sdout,
		
		diagout_cfebjtag => diagout_cfebjtag,

-- From/To FIFOs

		tfifo_data => tfifo_data,
		tfifo_wc => tfifo_wc,
		tfifo_rc => x"000",
		tfifo_str => tfifo_str,
		tfifo_wr_en => tfifo_wr_en,
		tfifo_rd_en => tfifo_rd_en,
		tfifo_sel => tfifo_sel,
		tfifo_mode => tfifo_mode,
		tfifo_rst => tfifo_rst,
    -- BPI controls
	BPI_RST           => vme_bpi_rst,        -- Resets BPI interface state machines
	BPI_CMD_FIFO_DATA => bpi_cmd_fifo_data,  -- Data for command FIFO
	BPI_WE            => bpi_we,             -- Command FIFO write enable  (pulse one clock cycle for one write)
	BPI_RE            => bpi_re,             -- Read back FIFO read enable  (pulse one clock cycle for one read)
	BPI_DSBL          => bpi_dsbl,           -- Disable parsing of BPI commands in the command FIFO (while being filled)
	BPI_ENBL          => bpi_enbl,           -- Enable  parsing of BPI commands in the command FIFO
	BPI_RBK_FIFO_DATA => bpi_rbk_fifo_data,  -- Data on output of the Read back FIFO
	BPI_RBK_WRD_CNT   => bpi_rbk_wrd_cnt,    -- Word count of the Read back FIFO (number of available reads)
	BPI_STATUS        => bpi_status,         -- FIFO status bits and latest value of the PROM status register. 
	BPI_TIMER         => bpi_timer           -- General timer

);


-- DMB_CTRL FPGA

b2v_mbc : dmb_ctrl
PORT MAP (

		ccb_cmd => ccb_cmd,												-- ccbcmnd(5 downto 0) - from J3
		ccb_cmd_s => ccb_cmd_s,											-- ccbcmnd(6) - from J3
		ccb_data => ccb_data,											-- ccbdata(7 downto 0) - from J3
		ccb_data_s => ccb_data_s,										-- ccbdata(8) - from J3
		ccb_cal => ccb_cal,												-- ccbcal(2 downto 0) - from J3
		ccb_crsv => ccb_crsv,											-- NEW [ccbrsv(6)], ccbrsv(3 downto 0) - from J3
		ccb_drsv => ccb_drsv,											-- ccbrsv(5 downto 4) - from J3
		ccb_rsvo => ccb_rsvo,											-- NEW [ccbrsv(11)], ccbrsv(10 downto 7) - from J3
		ccb_rsvi => ccb_rsvi,											-- ccbrsv(14 downto 12) - to J3
		ccb_bx0 => ccb_bx0,												-- bx0 - from J3
		ccb_bxrst => ccb_bxrst,											-- bxrst - from J3
		ccb_l1acc => ccb_l1acc,											-- l1acc - from J3
		ccb_l1arst => ccb_l1arst,										-- l1rst - from J3
		ccb_l1rls => ccb_l1rls,											-- l1rls - to J3
		ccb_clken => ccb_clken,											-- clken - from J3

		rawlct => rawlct,													-- rawlct(5 downto 0) - from J4
		lctdav1 => lctdav1,												-- lctdav1 - from J4
		lctdav2 => lctdav2,												-- lctdav2 - from J4
		lctrqst => lctrqst,												-- lctrqst(2 downto 1) - to J4
		rsvtd_in => rsvtd_in,											-- spare(7 DOWNTO 3) - to J4
--		rsvtd_out => rsvtd_out(6 downto 3),											-- spare(7 DOWNTO 3) - from J4
		rsvtd_out => rsvtd_out,											-- spare(2 DOWNTO 0) - from J4

-- From GigaLinks

		grx0_data => "0000000000000000",								-- glin(15 downto 0)									  
		grx0_data_valid => '0',		 
		grx1_data => "0000000000000000",								-- glin(15 downto 0)											  
		grx1_data_valid => '0',			 
	
-- To GigaLinks

		gtx0_data => gtx0_data,											-- dout(15 downto 0)											  
		gtx0_data_valid => gtx0_data_valid,												
		gtx1_data => gtx1_data,													-- dout(15 downto 0)											  
		gtx1_data_valid => gtx1_data_valid,												
	
-- From/To FIFOs

		fifo_rd_ck => fifo_rd_ck,										  
		fifo_rd_en => fifo_rd_en,										  
		fifo_sel => fifo_sel,			 

		fifo_out => fifo_out,				

		fifo_mrst_b => fifo_mrst_b,									-- ok -> fifo_mrst* - to FIFOs 
		fifo_prst_b => fifo_prst_b,									-- ok -> fifo_prst* - to FIFOs 

		fifo_full_b => fifo_full,									-- full*(7 DOWNTO 1) - from FIFOs 
		fifo_half_b => fifo_half,									-- half*(7 DOWNTO 1) - from FIFOs 
		fifo_pae_b => fifo_pae,										-- paef*(7 DOWNTO 1) - from FIFOs 
		fifo_empty_b => fifo_empty,									-- emptyf*(7 DOWNTO 1) - from FIFOs 

-- From/To DCFEBs (FF-EMU-MOD)

		ul_dav => ul_dav,															-- davf(5 DOWNTO 1) - from DCFEBs 
		ul_movlp => ul_movlp,													-- movlp(5 DOWNTO 1) - from DCFEBs

		dl_lct => dl_lct, 														-- lctf(5 DOWNTO 1) - to DCFEBs
		dl_gtrig =>	dl_gtrig,													-- febrst - to DCFEBs
		dl_injpulse => dl_injpulse,											-- inject - to DCFEBs
		dl_extpulse => dl_extpulse											-- extpulse - to DCFEBs

);

-- OT Manager
	  
b2v_otm : ot_mgr
PORT MAP (
		 otx1_tx_en => otx1_tx_en,
		 otx1_tx_dis => otx1_tx_dis,
		 otx1_reset => otx1_reset,
		 otx1_fault => otx1_fault,
		 otx2_tx_en => otx2_tx_en,
		 otx2_tx_dis => otx2_tx_dis,
		 otx2_reset => otx2_reset,
		 otx2_fault => otx2_fault,
		 orx1_rx_en => orx1_rx_en,
		 orx1_en_sd => orx1_en_sd,
		 orx1_sd => orx1_sd,
		 orx1_sq_en => orx1_sq_en,
		 orx2_rx_en => orx2_rx_en,
		 orx2_en_sd => orx2_en_sd,
		 orx2_sd => orx2_sd,
		 orx2_sq_en => orx2_sq_en);


   fifo_rst <= por or tfifo_rst;

b2v_dmb_rcv : dmb_receiver
   port map (
	-- ChipScopePro logic analyzer
	CSP_GTX_MAC_LA_CTRL => csp_gtx_mac_la_ctrl,
	CSP_PKT_FRM_LA_CTRL => csp_pkt_frm_la_ctrl,
	CSP_FIFO_LA_CTRL => csp_fifo_la_ctrl,

	-- 
   RST => fifo_rst,
	-- external signals
	ORX2_01_N => orx2_01_n,
	ORX2_01_P => orx2_01_p,
	ORX2_02_N => orx2_02_n,
	ORX2_02_P => orx2_02_p,
	ORX2_03_N => orx2_03_n,
	ORX2_03_P => orx2_03_p,
	ORX2_04_N => orx2_04_n,
	ORX2_04_P => orx2_04_p,
	ORX2_05_N => orx2_05_n,
	ORX2_05_P => orx2_05_p,
	ORX2_06_N => orx2_06_n,
	ORX2_06_P => orx2_06_p,
	ORX2_07_N => orx2_07_n,
	ORX2_07_P => orx2_07_p,
	ORX2_08_N => orx2_08_n,
	ORX2_08_P => orx2_08_p,
	ORX2_09_N => orx2_09_n,
	ORX2_09_P => orx2_09_p,
	ORX2_10_N => orx2_10_n,
	ORX2_10_P => orx2_10_p,
	ORX2_11_N => orx2_11_n,
	ORX2_11_P => orx2_11_p,
	ORX2_12_N => orx2_12_n,
	ORX2_12_P => orx2_12_p,
	-- Internal signals
	FIFO_VME_MODE => tfifo_mode,
	FIFO_SEL => tfifo_sel,
	RD_EN_FF => tfifo_rd_en,
	WR_EN_FF => tfifo_wr_en,
	FF_DATA_IN => vme_data_in,
	FF_DATA_OUT => tfifo_data,
	FF_WRD_CNT => tfifo_wc,
	FF_STATUS => tfifo_str,
	DMBVME_CLK_S2 => dmbvme_clk_s2,
	DAQ_RX_125REFCLK => clk125,
	DAQ_RX_160REFCLK_115_0 => cdc_clk(2)
  );

			

	dual_data_leds <= x"0000";     -- Data provided to BPI interface for non BPI communications 16 bits
   bpi_rst <= por or vme_bpi_rst;
	
BPI_ctrl_i : BPI_ctrl 
	port map (
	-- ChipScopePro logic analyzer and virtual I/O
	BPI_VIO_CNTRL => csp_bpi_vio_ctrl,
	BPI_LA_CNTRL => csp_bpi_la_ctrl,

	-- 
   CLK => clk40,                           -- 40 MHz clock
   CLK1MHZ => clk1mhz,                     --  1 MHz clock for timers
   RST => bpi_rst,
	-- Interface Signals to/from VME interface
	BPI_CMD_FIFO_DATA => bpi_cmd_fifo_data, -- Data for command FIFO
	BPI_WE => bpi_we,                       -- Command FIFO write enable  (pulse one clock cycle for one write)
	BPI_RE => bpi_re,                       -- Read back FIFO read enable  (pulse one clock cycle for one read)
	BPI_DSBL => bpi_dsbl,                   -- Disable parsing of BPI commands in the command FIFO (while being filled)
	BPI_ENBL => bpi_enbl,                   -- Enable  parsing of BPI commands in the command FIFO
	BPI_RBK_FIFO_DATA => bpi_rbk_fifo_data, -- Data on output of the Read back FIFO
	BPI_RBK_WRD_CNT => bpi_rbk_wrd_cnt,     -- Word count of the Read back FIFO (number of available reads)
	BPI_STATUS => bpi_status,               -- FIFO status bits and latest value of the PROM status register. 
	BPI_TIMER => bpi_timer,                 -- General timer
	-- Signals to/from low level BPI interface
	BPI_BUSY => bpi_busy,                   -- Operation in progress signal (not ready)
	BPI_DATA_FROM => bpi_data_from,         -- Data read from FLASH device      -- Data read from FLASH device
	BPI_LOAD_DATA => bpi_load_data,         -- Clock enable signal for capturing Data read from FLASH device
	BPI_ACTIVE => bpi_active,               -- output set to 1 when data lines are for BPI communications.
	BPI_OP => bpi_op,                       -- Operation: 00-standby, 01-write, 10-read, 11-not allowed(standby)
	BPI_ADDR => bpi_addr,                   -- Bank/Array Address
	BPI_DATA_TO => bpi_data_to,             -- Command or Data being written to FLASH device
	BPI_EXECUTE => bpi_execute
 );
 
bpi_interface_i : bpi_interface
	port map (
   CLK => clk40,                           -- 40 MHz clock
   RST => por,
	ADDR => bpi_addr,                       -- Bank/Array Address 
	CMD_DATA_OUT => bpi_data_to,            -- Command or Data being written to FLASH device
	OP => bpi_op,                           -- Operation: 00-standby, 01-write, 10-read, 11-not allowed(standby)
	EXECUTE => bpi_execute,
	DATA_IN => bpi_data_from,               -- Data read from FLASH device
	LOAD_DATA => bpi_load_data,             -- Clock enable signal for capturing Data read from FLASH device
	BUSY => bpi_busy,                       -- Operation in progress signal (not ready)
	-- signals for Dual purpose data lines
	BPI_ACTIVE => bpi_active,               -- set to 1 when data lines are for BPI communications.
	DUAL_DATA => dual_data_leds,            -- Data provided for non BPI communications
	-- external connections cooresponding to I/O pins
	BPI_AD => prom_a,
	CFG_DAT => prom_d,
	RS0 => prom_a_21_rs0,
	RS1 => prom_a_22_rs1,
	FCS_B => prom_cs_b,
	FOE_B => prom_oe_b,
	FWE_B => prom_we_b,
	FLATCH_B => prom_le_b
);


END DMB_V6_7FF_ARCH;