--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   13:31:50 03/13/2013
-- Design Name:   
-- Module Name:   C:/Users/bylsma/Projects/ODMB/firmware/DMB_OSU_V3_fifo/vme_bpi_sim_tb.vhd
-- Project Name:  DMB_OSU_V3_fifo
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: dmb_vme_sim
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY vme_bpi_sim_tb IS
END vme_bpi_sim_tb;
 
ARCHITECTURE behavior OF vme_bpi_sim_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT dmb_vme_sim
    PORT(
         vme_addr : IN  std_logic_vector(23 downto 1);
         vme_data_in : IN  std_logic_vector(15 downto 0);
         vme_data_out : OUT  std_logic_vector(15 downto 0);
         vme_am : IN  std_logic_vector(5 downto 0);
         vme_ga : IN  std_logic_vector(4 downto 0);
         vme_gap : IN  std_logic;
         vme_ds_b : IN  std_logic_vector(1 downto 0);
         vme_as_b : IN  std_logic;
         vme_lword_b : IN  std_logic;
         vme_write_b : IN  std_logic;
         vme_iack_b : IN  std_logic;
         vme_sysreset_b : IN  std_logic;
         vme_sysfail_b : IN  std_logic;
         vme_sysfail_out : OUT  std_logic;
         vme_berr_b : IN  std_logic;
         vme_berr_out : OUT  std_logic;
         vme_dtack_b : INOUT  std_logic;
         vme_tovme : OUT  std_logic;
         vme_tovme_b : OUT  std_logic;
         vme_doe : OUT  std_logic;
         vme_doe_b : OUT  std_logic;
         clk : IN  std_logic;
         clk_s1 : IN  std_logic;
         clk_s2 : IN  std_logic;
         clk_s3 : IN  std_logic;
         rst : IN  std_logic;
         BPI_RST : OUT  std_logic;
         BPI_CMD_FIFO_DATA : OUT  std_logic_vector(15 downto 0);
         BPI_WE : OUT  std_logic;
         BPI_RE : OUT  std_logic;
         BPI_DSBL : OUT  std_logic;
         BPI_ENBL : OUT  std_logic;
         BPI_RBK_FIFO_DATA : IN  std_logic_vector(15 downto 0);
         BPI_RBK_WRD_CNT : IN  std_logic_vector(10 downto 0);
         BPI_STATUS : IN  std_logic_vector(15 downto 0);
         BPI_TIMER : IN  std_logic_vector(31 downto 0)
        );
    END COMPONENT;
    
COMPONENT vme_strobe_sim_FSM is
  
port (
    CLK   : in std_logic;
    RST   : in std_logic;
    GO    : in std_logic;
    DTACK : in std_logic;
    AS    : out std_logic;
    DS0   : out std_logic;
    DS1   : out std_logic
);
END COMPONENT;


   --Inputs
   signal full_vme_addr : std_logic_vector(23 downto 0) := x"180000";
   signal vme_addr : std_logic_vector(23 downto 1);
   signal vme_data_in : std_logic_vector(15 downto 0) := (others => '0');
   signal vme_am : std_logic_vector(5 downto 0) := "111001";
   signal vme_ga : std_logic_vector(4 downto 0) := "11100";
   signal vme_gap : std_logic := '0';
   signal vme_ds_b : std_logic_vector(1 downto 0) := (others => '1');
   signal vme_as_b : std_logic := '1';
   signal vme_ds0, vme_ds1 : std_logic;
   signal vme_as : std_logic := '1';
   signal vme_lword_b : std_logic := '1';
   signal vme_write_b : std_logic := '1';
   signal vme_iack_b : std_logic := '1';
   signal vme_sysreset_b : std_logic := '1';
   signal vme_sysfail_b : std_logic := '1';
   signal vme_berr_b : std_logic := '1';
   signal vclk : std_logic := '0';
   signal clk : std_logic := '0';
   signal clk_s1 : std_logic := '0';
   signal clk_s2 : std_logic := '0';
   signal clk_s3 : std_logic := '0';
   signal rst : std_logic := '1';
   signal BPI_RBK_FIFO_DATA : std_logic_vector(15 downto 0) := x"FACE";
   signal BPI_RBK_WRD_CNT : std_logic_vector(10 downto 0) := "000" & x"43";
   signal BPI_STATUS : std_logic_vector(15 downto 0) := x"4321";
   signal BPI_TIMER : std_logic_vector(31 downto 0) := x"12345678";
   signal go : std_logic := '0';

	--BiDirs
   signal vme_dtack_b : std_logic;

 	--Outputs
   signal vme_data_out : std_logic_vector(15 downto 0);
   signal vme_sysfail_out : std_logic;
   signal vme_berr_out : std_logic;
   signal vme_tovme : std_logic;
   signal vme_tovme_b : std_logic;
   signal vme_doe : std_logic;
   signal vme_doe_b : std_logic;
   signal BPI_RST : std_logic;
   signal BPI_CMD_FIFO_DATA : std_logic_vector(15 downto 0);
   signal BPI_WE : std_logic;
   signal BPI_RE : std_logic;
   signal BPI_DSBL : std_logic;
   signal BPI_ENBL : std_logic;


   -- Clock period definitions
   constant vclk_period : time := 4 ns;
   constant clk_period : time := 24 ns;
   constant clk_s1_period : time := 96 ns;
   constant clk_s2_period : time := 384 ns;
   constant clk_s3_period : time := 768 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: dmb_vme_sim PORT MAP (
          vme_addr => vme_addr,
          vme_data_in => vme_data_in,
          vme_data_out => vme_data_out,
          vme_am => vme_am,
          vme_ga => vme_ga,
          vme_gap => vme_gap,
          vme_ds_b => vme_ds_b,
          vme_as_b => vme_as_b,
          vme_lword_b => vme_lword_b,
          vme_write_b => vme_write_b,
          vme_iack_b => vme_iack_b,
          vme_sysreset_b => vme_sysreset_b,
          vme_sysfail_b => vme_sysfail_b,
          vme_sysfail_out => vme_sysfail_out,
          vme_berr_b => vme_berr_b,
          vme_berr_out => vme_berr_out,
          vme_dtack_b => vme_dtack_b,
          vme_tovme => vme_tovme,
          vme_tovme_b => vme_tovme_b,
          vme_doe => vme_doe,
          vme_doe_b => vme_doe_b,
          clk => clk,
          clk_s1 => clk_s1,
          clk_s2 => clk_s2,
          clk_s3 => clk_s3,
          rst => rst,
          BPI_RST => BPI_RST,
          BPI_CMD_FIFO_DATA => BPI_CMD_FIFO_DATA,
          BPI_WE => BPI_WE,
          BPI_RE => BPI_RE,
          BPI_DSBL => BPI_DSBL,
          BPI_ENBL => BPI_ENBL,
          BPI_RBK_FIFO_DATA => BPI_RBK_FIFO_DATA,
          BPI_RBK_WRD_CNT => BPI_RBK_WRD_CNT,
          BPI_STATUS => BPI_STATUS,
          BPI_TIMER => BPI_TIMER
        );

   -- Clock process definitions
   vclk_process :process
   begin
		vclk <= '0';
		wait for vclk_period/2;
		vclk <= '1';
		wait for vclk_period/2;
   end process;
 
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 
   clk_s1_process :process
   begin
		clk_s1 <= '0';
		wait for clk_s1_period/2;
		clk_s1 <= '1';
		wait for clk_s1_period/2;
   end process;
 
   clk_s2_process :process
   begin
		clk_s2 <= '0';
		wait for clk_s2_period/2;
		clk_s2 <= '1';
		wait for clk_s2_period/2;
   end process;
 
   clk_s3_process :process
   begin
		clk_s3 <= '0';
		wait for clk_s3_period/2;
		clk_s3 <= '1';
		wait for clk_s3_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10;
		rst <= '0';
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"4020";
		vme_write_b <= '0';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		vme_data_in <= x"DEAD";
		full_vme_addr(18 downto 0) <= "000" & x"402C";
		vme_write_b <= '0';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"4024";
		vme_write_b <= '0';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"4028";
		vme_write_b <= '0';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"4030";
		vme_write_b <= '1';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"4034";
		vme_write_b <= '1';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"4038";
		vme_write_b <= '1';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"403C";
		vme_write_b <= '1';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		
      wait for clk_period*10;
		full_vme_addr(18 downto 0) <= "000" & x"4040";
		vme_write_b <= '1';
		wait for 8ns;
		go <= '1';
		wait for 50ns;
		go <= '0';
		

      wait;
   end process;
	vme_addr <= full_vme_addr(23 downto 1);
	vme_as_b <= not vme_as;
	vme_ds_b <= (not vme_ds1 & not vme_ds0);

strobe_sim : vme_strobe_sim_FSM

PORT MAP (

  CLK => vclk,
  RST => rst,
  GO => go,
  DTACK => not vme_dtack_b,
  AS => vme_as,
  DS0 => vme_ds0,
  DS1 => vme_ds1
);

END;
